/* NOSHIP */
#ifndef _ICONTLST_
#define _ICONTLST_
/*******************************************************************************
* FILE NAME: icontlst.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of class(es):                                                  *
*     INumberToObjectElement                                                   *
*     IObjectToNumberElement                                                   *
*     IContextElementSet                                                       *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
* ADDITONAL COPYRIGHTS:                                                        *
*  Copyright (C) 1996, Taligent, Inc. All rights reserved.                     *
*  Copyright (C) 1996, Lotus Development Corporation. All Rights Reserved.     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>
#include <icontext.hpp>
#include <iksset.h>


#pragma pack(4)

#ifdef IC_WIN


class INumberToObjectElement {
public:

  INumberToObjectElement ( IContext::ObjectNumber i,
                       const void* p)
          : fNumber(i),
            fObject(p) {}
IContext::ObjectNumber const
 &number     ( ) const { return fNumber; }

const void *const
 &object     ( ) const { return fObject; }

private:
IContext::ObjectNumber
  fNumber;
const void
 *fObject;
};

inline IContext::ObjectNumber const& key(const INumberToObjectElement& k)
{
    return k.number();
}

class IObjectToNumberElement {
public:
    IObjectToNumberElement(const void* p, IContext::ObjectNumber i) : fNumber(i), fObject(p) {}
    IContext::ObjectNumber const& number() const { return fNumber; }
    const void* const& object() const { return fObject; }

private:
    IContext::ObjectNumber    fNumber;
    const void*          fObject;
};

inline void* const& key(const IObjectToNumberElement& k)
{
    return (void*)k.object();
}



// Note: Examine for possible optimization by using a specialized collection.
class IContextNumberSet : public  IKeySortedSet<INumberToObjectElement, IContext::ObjectNumber>
{
public:
  IContextNumberSet ( )
   : IKeySortedSet<INumberToObjectElement, IContext::ObjectNumber>(100) {}
 ~IContextNumberSet ( ) {}
};


class IContextElementSet : public IKeySortedSet<IObjectToNumberElement, void*>
{
public:
  IContextElementSet ( )
   : IKeySortedSet<IObjectToNumberElement, void*>(100) {}
 ~IContextElementSet ( ) {}
};


#endif /* IC_WIN */

#pragma pack()

#endif // _ICONTLST_
