/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IEXC_H
#define _IEXC_H

#include <iiglobal.h>
#include <iexcbase.hpp>
#include <iexctxt.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#if defined (__RRBC_LIB__)
#define __RRBC_EXC__
#undef  __RRBC_LIB__
#endif

#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif

class IPreconditionViolation : public IException {
public:

           IPreconditionViolation
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IPreconditionViolation
                            (IPreconditionViolation const&);

  virtual ~IPreconditionViolation
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IPreconditionViolation const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IPreconditionViolation\
                            (char const*, unsigned long, Severity),\
           operator=        (IPreconditionViolation const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IFullException : public IPreconditionViolation {
public:

           IFullException   (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IFullException   (IFullException const&);

  virtual ~IFullException   ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IFullException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IFullException   (char const*, unsigned long, Severity),\
           operator=        (IFullException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IEmptyException : public IPreconditionViolation {
public:

           IEmptyException  (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IEmptyException  (IEmptyException const&);

  virtual ~IEmptyException  ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IEmptyException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IEmptyException \
                            (char const*, unsigned long, Severity),\
           operator=        (IEmptyException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class INotEmptyException : public IPreconditionViolation {
public:

           INotEmptyException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           INotEmptyException
                            (INotEmptyException const&);

  virtual ~INotEmptyException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (INotEmptyException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           INotEmptyException\
                            (char const*, unsigned long, Severity),\
           operator=        (INotEmptyException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class INotBoundedException : public IPreconditionViolation {
public:

           INotBoundedException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           INotBoundedException
                            (INotBoundedException const&);

  virtual ~INotBoundedException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (INotBoundedException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           INotBoundedException\
                            (char const*, unsigned long, Severity),\
           operator=        (INotBoundedException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class ICursorInvalidException : public IPreconditionViolation {
public:

           ICursorInvalidException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           ICursorInvalidException
                            (ICursorInvalidException const&);

  virtual ~ICursorInvalidException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (ICursorInvalidException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ICursorInvalidException\
                            (char const*, unsigned long, Severity),\
           operator=        (ICursorInvalidException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IPositionInvalidException : public IPreconditionViolation {
public:

           IPositionInvalidException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IPositionInvalidException
                            (IPositionInvalidException const&);

  virtual ~IPositionInvalidException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IPositionInvalidException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IPositionInvalidException\
                            (char const*, unsigned long, Severity),\
           operator=        (IPositionInvalidException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class INotContainsKeyException : public IPreconditionViolation {
public:

           INotContainsKeyException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           INotContainsKeyException
                            (INotContainsKeyException const&);

  virtual ~INotContainsKeyException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (INotContainsKeyException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           INotContainsKeyException\
                            (char const*, unsigned long, Severity),\
           operator=        (INotContainsKeyException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IKeyAlreadyExistsException : public IPreconditionViolation {
public:

           IKeyAlreadyExistsException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IKeyAlreadyExistsException
                            (IKeyAlreadyExistsException const&);

  virtual ~IKeyAlreadyExistsException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IKeyAlreadyExistsException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IKeyAlreadyExistsException\
                            (char const*, unsigned long, Severity),\
           operator=        (IKeyAlreadyExistsException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IRootAlreadyExistsException : public IPreconditionViolation {
public:

           IRootAlreadyExistsException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IRootAlreadyExistsException
                            (IRootAlreadyExistsException const&);

  virtual ~IRootAlreadyExistsException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IRootAlreadyExistsException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IRootAlreadyExistsException\
                            (char const*, unsigned long, Severity),\
           operator=        (IRootAlreadyExistsException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IChildAlreadyExistsException : public IPreconditionViolation {
public:

           IChildAlreadyExistsException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IChildAlreadyExistsException
                            (IChildAlreadyExistsException const&);

  virtual ~IChildAlreadyExistsException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IChildAlreadyExistsException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IChildAlreadyExistsException\
                            (char const*, unsigned long, Severity),\
           operator=        (IChildAlreadyExistsException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IIdenticalCollectionException : public IPreconditionViolation {
public:

           IIdenticalCollectionException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IIdenticalCollectionException
                            (IIdenticalCollectionException const&);

  virtual ~IIdenticalCollectionException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IIdenticalCollectionException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IIdenticalCollectionException\
                            (char const*, unsigned long, Severity),\
           operator=        (IIdenticalCollectionException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IInvalidReplacementException : public IPreconditionViolation {
public:

           IInvalidReplacementException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IInvalidReplacementException
                            (IInvalidReplacementException const&);

  virtual ~IInvalidReplacementException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IInvalidReplacementException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IInvalidReplacementException\
                            (char const*, unsigned long, Severity),\
           operator=        (IInvalidReplacementException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class ICyclicAttachException : public IPreconditionViolation {
public:

           ICyclicAttachException
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           ICyclicAttachException
                            (ICyclicAttachException const&);

  virtual ~ICyclicAttachException
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (ICyclicAttachException const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           ICyclicAttachException\
                            (char const*, unsigned long, Severity),\
           operator=        (ICyclicAttachException const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};

class IOutOfCollectionMemory : public IOutOfMemory {
public:

           IOutOfCollectionMemory
                            (char const*, unsigned long = 0,
                             Severity = IException::unrecoverable);

           IOutOfCollectionMemory
                            (IOutOfCollectionMemory const&);

  virtual ~IOutOfCollectionMemory
                            ();

  virtual
  char const*
           name             () const;

  static
  void     throwIt          (unsigned long,
                             char const*, unsigned long);

protected:

private:

  void     operator=        (IOutOfCollectionMemory const&);

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           IOutOfCollectionMemory\
                            (char const*, unsigned long, Severity),\
           operator=        (IOutOfCollectionMemory const&),\
           throwIt          (unsigned long,\
                             char const*, unsigned long)\
                        )
#endif

};



#pragma SOMAsDefault (pop)

#if defined (__RRBC_EXC__)
#define __RRBC_LIB__
#undef __RRBC_EXC__
#endif

#pragma info (restore)
#pragma pack ()

#endif
