/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IIAES_H
#define _IIAES_H

#include <iiacllct.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif

class IAEqualitySequenceImpl : public IACollectionImpl {
public:

          ~IAEqualitySequenceImpl
                            ();

  virtual
  long     Compare          (IAEqualitySequenceImpl const&,
                             ICompFunc, void*) const;

  virtual
  IBoolean LocateFirst      (void const*, ICursorImpl&) const = 0;

  virtual
  IBoolean LocateLast       (void const*, ICursorImpl&) const = 0;

  virtual
  IBoolean LocatePrevious   (void const*, ICursorImpl&) const = 0;

  virtual
  IBoolean operator==       (IAEqualitySequenceImpl const&) const = 0;

  IBoolean operator!=       (IAEqualitySequenceImpl const&) const;

protected:

           IAEqualitySequenceImpl
                            (Ops&);

private:

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMClassVersion (*, 5, 0)
#pragma SOMReleaseOrder (\
           Compare          (IAEqualitySequenceImpl const&,\
                             ICompFunc, void*) const,\
           LocateFirst      (void const*, ICursorImpl&) const,\
           LocateLast       (void const*, ICursorImpl&) const,\
           LocatePrevious   (void const*, ICursorImpl&) const,\
           operator==       (IAEqualitySequenceImpl const&) const,\
           operator!=       (IAEqualitySequenceImpl const&) const,\
           IAEqualitySequenceImpl\
                            (Ops&)\
                        )
#endif

};

#pragma SOMAsDefault (pop)

#pragma info (restore)
#pragma pack ()

#endif
