/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

// --------------------------
// IKeyBagOnKeySortedBagMngCursorImpl
// --------------------------

// public members

template <class Base>
IKeyBagOnKeySortedBagMngCursorImpl <Base>::
IKeyBagOnKeySortedBagMngCursorImpl
  (IKeyBagOnKeySortedBagImpl <Base> const& collection)
: Inherited (IKeyBagOnKeySortedBagImpl <Base>::BaseOf (collection))
{ ivCollection = &collection;
}

template <class Base>
IKeyBagOnKeySortedBagMngCursorImpl <Base>::
~IKeyBagOnKeySortedBagMngCursorImpl ()
{
}

// -------------------------
// IKeyBagOnKeySortedBagImpl
// -------------------------

// public members

template <class Base>
IKeyBagOnKeySortedBagImpl <Base>::
IKeyBagOnKeySortedBagImpl (Ops& ops, INumber)
: IAKeyBagImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IKeyBagOnKeySortedBagImpl <Base>::
IKeyBagOnKeySortedBagImpl
  (Ops& ops, IKeyBagOnKeySortedBagImpl <Base> const&)
: IAKeyBagImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
IKeyBagOnKeySortedBagImpl <Base>::
~IKeyBagOnKeySortedBagImpl ()
{
}

template <class Base>
void
IKeyBagOnKeySortedBagImpl <Base>::
AddAllFrom (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ()) {
    Self const& ks = (Self const&)collection;
    BaseOf (*this).Base::AddAllFrom (BaseOf (ks));
  }
  else
    Inherited::AddAllFrom (collection);
}

template <class Base>
IACollectionImpl*
IKeyBagOnKeySortedBagImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
IBoolean
IKeyBagOnKeySortedBagImpl <Base>::
ContainsAllKeysFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    return BaseOf (*this).
      Base::ContainsAllKeysFrom (BaseOf ((Self const&)collection));
  }
  else
    return Inherited::ContainsAllKeysFrom (collection);
}

template <class Base>
void
IKeyBagOnKeySortedBagImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
IKeyBagOnKeySortedBagImpl <Base>::Cursor*
IKeyBagOnKeySortedBagImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
IKeyBagOnKeySortedBagImpl <Base>::MngCursor*
IKeyBagOnKeySortedBagImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

#pragma info (restore)
#pragma pack ()
