/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IIKSBDIL_H
#define _IIKSBDIL_H

#include <iiksbseq.h>

#if defined (__LIB_BUILD__)
#define __2nd_LEVEL__
#endif

#include <iiseqdil.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif

typedef IKeySortedBagOnSequenceImpl
         <ISequenceAsDilTableImpl> IKeySortedBagAsDilTableImpl;

template <class Element, class _Key,
          class ElementOps, class Implementation>
class IKeySortedBagAsDilTableOps :
  public IAKeySortedBagOnSequenceOps <ISequenceAsDilTableImpl> {

  typedef  IKeySortedBagAsDilTableOps
            <Element, _Key, ElementOps, Implementation> Self;

  typedef  ISequenceAsDilTableOps
            <Element, ElementOps, ISequenceAsDilTableImpl> Base;

public:

  typedef  Implementation ImplType;

  typedef  Element ElementType;

  typedef  _Key KeyType;

           IKeySortedBagAsDilTableOps
                           (INumber);

           IKeySortedBagAsDilTableOps
                           (INumber, void*);

           IKeySortedBagAsDilTableOps
                           (IKeySortedBagAsDilTableOps
                             <Element, _Key,
                              ElementOps, Implementation> const&);

          ~IKeySortedBagAsDilTableOps
                           ();

  IACollectionImpl*
           Clone           () const;

  long     CompareKeys     (void const*, void const*, IArgType) const;

  void*    Key             (void const*) const;

  TStream& operator<<=     (TStream&);

  TStream& operator>>=     (TStream&) const;

           operator ISequenceAsDilTableImpl&
                           ();

           operator Implementation*
                           ();


protected:

private:

  ElementOps
           ivElementOps;
 
  Base     ivBase;

  Implementation
           ivImpl;

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMReleaseOrder (\
           IKeySortedBagAsDilTableOps\
                            (INumber),\
           IKeySortedBagAsDilTableOps\
                            (INumber, void*),\
           operator Implementation*\
                            ()\
                        )
#endif 

};

#pragma SOMAsDefault (pop)

#if ! defined (__TEMPINC__)
#include <iiksbdil.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
