/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IIKSHSH_H
#define _IIKSHSH_H

#include <iikskb.h>

#if defined (__LIB_BUILD__)
#define __2nd_LEVEL__
#endif

#include <iikbhsh.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif

typedef IKeySetOnKeyBagImpl
         <IKeyBagAsHshTableImpl> IKeySetAsHshTableImpl;

typedef IAKeySetOnKeyBagOps
         <IKeyBagAsHshTableImpl> IAKeySetAsHshTableOps;

template <class Element, class _Key,
          class ElementOps, class Implementation>
class IKeySetAsHshTableOps :
  public IAKeySetAsHshTableOps {

  typedef  IKeySetAsHshTableOps
            <Element, _Key, ElementOps, Implementation> Self;

  typedef  IKeyBagAsHshTableOps
            <Element, _Key,
             ElementOps, IKeyBagAsHshTableImpl> Base;

public:

  typedef  Implementation ImplType;

  typedef  Element ElementType;

  typedef  _Key KeyType;

           IKeySetAsHshTableOps
                           (INumber);

           IKeySetAsHshTableOps
                           (INumber, void*);

           IKeySetAsHshTableOps
                           (IKeySetAsHshTableOps
                             <Element, _Key,
                              ElementOps, Implementation> const&);

          ~IKeySetAsHshTableOps
                           ();

  IACollectionImpl*
           Clone           () const;

           operator IKeyBagAsHshTableImpl&
                           ();

           operator Implementation*
                           ();


protected:

private:

  Base     ivBase;

  Implementation
           ivImpl;

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__)
#pragma SOMReleaseOrder (\
           IKeySetAsHshTableOps\
                            (INumber),\
           IKeySetAsHshTableOps\
                            (INumber, void*),\
           operator Implementation*\
                            ()\
                        )
#endif 

};

#pragma SOMAsDefault (pop)

#if ! defined (__TEMPINC__)
#include <iikshsh.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
