/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#ifndef _IISBDIL_H
#define _IISBDIL_H

#include <iisbksb.h>

#if defined (__LIB_BUILD__)
#define __2nd_LEVEL__
#endif

#include <iiksbdil.h>


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

#if defined (__RRBC_LIB__)
#pragma SOMAsDefault (on)
#else
#pragma SOMAsDefault (off)
#endif

typedef ISortedBagOnKeySortedBagImpl
         <IKeySortedBagAsDilTableImpl> ISortedBagAsDilTableImpl;

typedef IASortedBagOnKeySortedBagOps
          <IKeySortedBagAsDilTableImpl> IASortedBagAsDilTableOps;

template <class Element, class ElementOps, class Implementation>
class ISortedBagAsDilTableOps :
  public IASortedBagAsDilTableOps {

  typedef  IASortedBagAsDilTableOps Inherited;

  typedef  ISortedBagAsDilTableOps
            <Element, ElementOps, Implementation> Self;

  typedef  IKeySortedBagAsDilTableOps
            <Element, Element, IOpsWithKey <Element, ElementOps>,
             IKeySortedBagAsDilTableImpl > Base;

public:

  typedef  Implementation ImplType;

  typedef  Element ElementType;

  typedef  void KeyType;

           ISortedBagAsDilTableOps
                           (INumber);

           ISortedBagAsDilTableOps
                           (INumber, void*);

           ISortedBagAsDilTableOps
                           (ISortedBagAsDilTableOps
                             <Element, ElementOps,
                              Implementation> const&);

          ~ISortedBagAsDilTableOps
                           ();

  IACollectionImpl*
           Clone           () const;

           operator IKeySortedBagAsDilTableImpl&
                           ();

           operator Implementation*
                           ();


protected:

private:

  Base     ivBase;

  Implementation
           ivImpl;

#if defined (__SOM_ENABLED__) && defined (__RRBC_LIB__) 
#pragma SOMReleaseOrder (\
           ISortedBagAsDilTableOps\
                            (INumber),\
           ISortedBagAsDilTableOps\
                            (INumber, void*),\
           operator Implementation*\
                            ()\
                        )
#endif 

};

#pragma SOMAsDefault (pop)

#if ! defined (__TEMPINC__)
#include <iisbdil.c>
#endif

#pragma info (restore)
#pragma pack ()

#endif
