/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

// --------------------------
// ISetOnKeySetMngCursorImpl
// --------------------------

// public members

template <class Base>
ISetOnKeySetMngCursorImpl <Base>::
ISetOnKeySetMngCursorImpl
  (ISetOnKeySetImpl <Base> const& collection)
: Inherited (ISetOnKeySetImpl <Base>::BaseOf (collection))
{ ivCollection = &collection;
}

template <class Base>
ISetOnKeySetMngCursorImpl <Base>::
~ISetOnKeySetMngCursorImpl ()
{
}

// ----------------
// ISetOnKeySetImpl
// ----------------

// public members

template <class Base>
ISetOnKeySetImpl <Base>::
ISetOnKeySetImpl (Ops& ops, INumber)
: IASetImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
ISetOnKeySetImpl <Base>::
ISetOnKeySetImpl (Ops& ops, ISetOnKeySetImpl <Base> const&)
: IASetImpl ((Inherited::Ops&)ops), ivBase (ops)
{ BaseOf (*this).IACollectionImpl::Initialize ();
}

template <class Base>
ISetOnKeySetImpl <Base>::
~ISetOnKeySetImpl ()
{
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
Add (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).Base::Add (element, cursor);
}

template <class Base>
void
ISetOnKeySetImpl <Base>::
AddAllFrom (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ()) {
    Self const& set = (Self const&)collection;
    BaseOf (*this).Base::AddAllFrom (BaseOf (set));
  }
  else
    Inherited::AddAllFrom (collection);
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
AllElementsDo (IApplFunc applFunc, void* addArg)
{ return BaseOf (*this).Base::AllElementsDo (applFunc, addArg);
}

template <class Base>
void*
ISetOnKeySetImpl <Base>::
Any () const
{ return BaseOf (*this).Base::Any ();
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
CheckCursor (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::CheckCursor (cursor);
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
CheckReplacement (ICursorImpl const& cursor, void const* element) const
{ return BaseOf (*this).Base::CheckReplacement (cursor, element);
}

template <class Base>
char const*
ISetOnKeySetImpl <Base>::
ClassName () const
{ return cvClassName;
}

template <class Base>
IACollectionImpl*
ISetOnKeySetImpl <Base>::
Clone () const
{ return (IACollectionImpl*) CheckPointer (OpsOf (*this).Clone ());
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
Contains (void const* element) const
{ return BaseOf (*this).ContainsElementWithKey (element);
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
ContainsAllFrom (IACollectionImpl const& collection) const
{ if (Self::ClassName () == collection.ClassName ()) {
    Self const& set = (Self const&)collection;
    return BaseOf (*this).
      Base::ContainsAllKeysFrom (BaseOf (set));
  }
  else
    return Inherited::ContainsAllFrom (collection);
}

template <class Base>
void
ISetOnKeySetImpl <Base>::
Copy (IACollectionImpl const& collection)
{ if (Self::ClassName () == collection.ClassName ())
    operator= ((Self const&)collection);
  else
    Inherited::Copy (collection);
}

template <class Base>
ISetOnKeySetImpl <Base>::Cursor*
ISetOnKeySetImpl <Base>::
CreateCursor () const
{ return (Cursor*) CheckPointer (new Cursor (*this));
}

template <class Base>
ISetOnKeySetImpl <Base>::MngCursor*
ISetOnKeySetImpl <Base>::
CreateMngCursor () const
{ return (MngCursor*) CheckPointer (new MngCursor (*this));
}

template <class Base>
void*
ISetOnKeySetImpl <Base>::
ElementAt (ICursorImpl const& cursor) const
{ return BaseOf (*this).Base::ElementAt (cursor);
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
IsBounded () const
{ return BaseOf (*this).Base::IsBounded ();
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
IsConsistent () const
{ return BaseOf (*this).Base::IsConsistent ();
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
IsEmpty () const
{ return BaseOf (*this).Base::IsEmpty ();
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
IsFull () const
{ return BaseOf (*this).Base::IsFull ();
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
Locate (void const* element, ICursorImpl& cursor) const
{ return BaseOf (*this).Base::LocateElementWithKey (element, cursor);
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
LocateOrAdd (void const* element, ICursorImpl& cursor)
{ return BaseOf (*this).
    Base::LocateOrAddElementWithKey (element, cursor);
}

template <class Base>
INumber
ISetOnKeySetImpl <Base>::
NumberOfElements () const
{ return BaseOf (*this).Base::NumberOfElements ();
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
Remove (void const* element)
{ return BaseOf (*this).Base::RemoveElementWithKey (element);
}

template <class Base>
INumber
ISetOnKeySetImpl <Base>::
RemoveAll ()
{ return BaseOf (*this).Base::RemoveAll ();
}

template <class Base>
INumber
ISetOnKeySetImpl <Base>::
RemoveAll (IPredFunc predFunc, void* addArg)
{ return BaseOf (*this).Base::RemoveAll (predFunc, addArg);
}

template <class Base>
void
ISetOnKeySetImpl <Base>::
RemoveAt (ICursorImpl& cursor)
{ BaseOf (*this).Base::RemoveAt (cursor);
}

template <class Base>
void
ISetOnKeySetImpl <Base>::
ReplaceAt (ICursorImpl const& cursor, void const* element)
{ BaseOf (*this).Base::ReplaceAt (cursor, element);
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
SetToFirst (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToFirst (cursor);
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
SetToNext (ICursorImpl& cursor) const
{ return BaseOf (*this).Base::SetToNext (cursor);
}

template <class Base>
IBoolean
ISetOnKeySetImpl <Base>::
operator== (IASetImpl const& collection) const
{ return (Self::NumberOfElements () == collection.NumberOfElements () &&
          ContainsAllFrom (collection));
}

template <class Base>
TStream&
ISetOnKeySetImpl <Base>::
operator<<= (TStream& fromWhere)
{ return (BaseOf (*this) <<= fromWhere);
}

template <class Base>
TStream&
ISetOnKeySetImpl <Base>::
operator>>= (TStream& toWhere) const
{ return (BaseOf (*this) >>= toWhere);
}

#pragma info (restore)
#pragma pack ()
