/**********************************************************************
*                                                                     *
*  IBM(R) VisualAge(TM) for C++ for Windows(R), Version 3.5           *
*                                                                     *
*  PID: 5622-880                                                      *
*  - Licensed Material - Program-Property of IBM                      *
*  (C) Copyright IBM Corp. 1991, 1995 - All Right Reserved.           *
*                                                                     *
*  US Government Users Restricted Rights - Use, duplication or        *
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  *
*                                                                     *
*  VisualAge, and IBM are trademarks or registered trademarks of      *
*  International Business Machines Corporation.                       *
*  Windows is a registered trademark of Microsoft Corporation.        *
*                                                                     *
**********************************************************************/

#include <imtree.h>

#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)
#pragma pack (4)

// ---------
// IMetaTree
// ---------

// protected members

IMetaTree::
~IMetaTree ()
{ if (ivImpl != 0)
    ivImpl->Delete ();
}

void
IMetaTree::
CloneImplOf (IMetaTree const& tree)
{ if (ivImpl != 0)
    ivImpl->Delete ();
  ivImpl = tree.ivImpl->Clone ();
  ivImpl->Initialize ();
}

void
IMetaTree::
SetImpl (IATreeImpl* impl)
{ if (ivImpl != 0)
    ivImpl->Delete ();
  ivImpl = impl;
  if (ivImpl == 0) {
    IATreeImpl::CheckPointer ((void*)0);
  }
  ivImpl->Initialize ();
}

#pragma info (restore)
#pragma pack ()
