/*******************************************************************************
* FILE NAME: istring3.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of the "conversion" functions for    *
*   the class IString.                                                         *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <istring.hpp>

#include <ibuffer.hpp>

// Segment definitions
#ifdef IC_PAGETUNE
  #define _ISTRING3_CPP_
  #include <ipagetun.h>
#endif


/*------------------------------------------------------------------------------
| IString::operator char*                                                      |
| IString::unsigned char*                                                      |
| IString::signed   char*                                                      |
| IString::asInt                                                               |
| IString::asUnsigned                                                          |
| IString::asDouble                                                            |
|                                                                              |
|                                                                              |
| Convert the string contents to the appropriate type, using the appropriate   |
| strto<x> library function.  Conversion to char* simply obtains the address   |
| of the associated buffer data.                                               |
------------------------------------------------------------------------------*/
// See istring.inl
