/* NOSHIP */
/*****************************************************************************
 *
 * asaspect.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * LIST OF CLASSES IN THIS FILE
 *      CAswAspect
 *
 * Description:
 *
 *
 *
 *****************************************************************************/

#ifndef ASWAN_ASASPECT_H
#define ASWAN_ASASPECT_H
#include <aspack.h>
typedef enum tagASWMISC
{
   ASWMISC_RECOMPOSEONRESIZE = 1,
   ASWMISC_ONLYICONIC,
   ASWMISC_INSERTNOTREPLACE,
   ASWMISC_STATIC,
   ASWMISC_CANTLINKINSIDE,
   ASWMISC_CANLINKBYOLE1,
   ASWMISC_ISLINKOBJECT,
   ASWMISC_INSIDEOUT,
   ASWMISC_ACTIVATEWHENVISIBLE,
   ASWMISC_NOSPECIALRENDERING
}
   ASWMISC;
class ASWPUBCLASS CAswAspect : public CAswBase
{
public:
   ASWPUBMETHOD CAswAspect( PASWCONTROL pAswControl ); 
   ASWPUBMETHOD ~CAswAspect( void ); 
   CAswResult ASWPUBMETHOD Setup( PASWCONTAINEDOBJECT pAswContainedObject, 
                                  DWORD               dwAspect = DVASPECT_CONTENT, 
                                  LONG                lIndex = -1 ); 
   CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE ); 
   inline DWORD GetAspect( void ) const
   {
      return (m_dwAspect);
   }
   CAswResult ASWPUBMETHOD SwitchAspect( PASWASPECT pAswAspect, 
                                         BOOL       bOldCacheFlag, 
                                         BOOL       bNewCacheFlag ); 
   CAswResult ASWPUBMETHOD SetAdvise( DWORD dwAdviseFlag = ADVF_PRIMEFIRST ); 
   BOOL ASWPUBMETHOD IsAdvise( void ); 
   CAswResult ASWPUBMETHOD DisconnectAdvise( void ); 
   virtual BOOL ASWPUBMETHOD OnViewChange( void );
   void ASWPUBMETHOD GetExtent( LPSIZEL lpsizelExtentsHiMetric ); 
   virtual void ASWPUBMETHOD OnExtentChange( SIZEL sizelNewExtentsHiMetric ); 
   enum GetExtentOptions
   { 
      MostApprop,       
      FromCacheOnly,    
      FromObjectOnly    
   };
   CAswResult ASWPUBMETHOD GetExtent( LPSIZEL          lpsizelHiMetricExtents, 
                                      GetExtentOptions uOptions );
   CAswResult ASWPUBMETHOD GetMiscStatus( UINT   uIndex, 
                                          LPBOOL lpFlag );
   inline void AddRendDevToList( PASWOBJRENDDEV pObjRendDev ) 
   { 
      m_lhListOfObjRendDevs.Insert(pObjRendDev);
   }   
   inline void RemoveRendDevFromList( PASWOBJRENDDEV pObjRendDev )
   { 
      m_lhListOfObjRendDevs.Remove(pObjRendDev);
   }    
   inline PASWOBJRENDDEV GetFirstRendDev( void )
   {
      return m_lhListOfObjRendDevs.GetFirst();
   }
   inline PASWOBJRENDDEV GetNextRendDev( void )
   {
      return m_lhListOfObjRendDevs.GetNext();
   }
   void HandleViewChange( void );
   void HandleShowAsBeingEditElsewhere( BOOL fShow );
   inline LONG GetIndex( void )
   {
      return m_lIndex;
   }
   inline void SetAspect( DWORD dwAspect, LONG lIndex )
   {
      m_dwAspect = dwAspect;
      m_lIndex = lIndex;
   }
   inline DWORD GetAdviseFlag(void )
   {
      return m_dwAdviseFlag;
   }
   inline void SetAdviseFlag( DWORD dwAdviseFlag )
   {
      m_dwAdviseFlag = dwAdviseFlag;
   }
   inline BOOL HasInitialExtentsBeenRetrieved( void )
   {
      return m_bRetrievedInitialExtents;
   }
   inline void MarkInitialExtentsAsBeingRetrieved( BOOL bRetieved = TRUE )
   {
      m_bRetrievedInitialExtents = bRetieved;
   }
   void GetInitialExtents( void );
   inline void SetPendingExtentChangeNotification( BOOL bPending = TRUE )
   {
      m_bPendingExtChgNotification = bPending;
   }
   inline BOOL IsPendingExtentChangeNotification(void)
   {
      return m_bPendingExtChgNotification;
   }
   CAswResult ASWPUBMETHOD RequestExtentChange (LPSIZEL lpsizelExtentsHiMetric);
   inline BOOL IsSetExtentNeededOnActivate(void)
   {
      return m_bSetExtentsOnActivate;
   }
   inline void SetExtentNeededOnActivateFlag( BOOL bSet )
   {
      m_bSetExtentsOnActivate = bSet;
   }
   inline void SetExtentsFromStreamInfo( SIZEL sizelExtents )
   {
      m_sizelExtents.cx = sizelExtents.cx;
      m_sizelExtents.cy = sizelExtents.cy;
   }
   PASWCONTAINEDOBJECT inline GetContainedObject(void)
   {
      return m_pAswContainedObject;
   }
public:
   CAswListEl     m_leAspectListElement; 
private:
   PASWCONTAINEDOBJECT        m_pAswContainedObject;
   CAswObjRendDevListHead     m_lhListOfObjRendDevs;
   DWORD                      m_dwAspect;
   LONG                       m_lIndex;
   DWORD                      m_dwAdviseFlag;
   SIZEL                      m_sizelExtents;
   BOOL                       m_bRetrievedInitialExtents;
   BOOL                       m_bPendingExtChgNotification;
   BOOL                       m_bSetExtentsOnActivate;
};
MAKELISTHEADCLASS(CAswAspect);
#include <aspop.h>
#endif      
