/* NOSHIP */
/*****************************************************************************
 *
 * Source Module: asdebout.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Purpose:       Debug output "device" class definitions for Aswan
 *                Toolkit debug trace facility.
 *
 *****************************************************************************/

#ifndef ASDEBOUT_H
#define ASDEBOUT_H
#ifndef _INC_STDLIB
#include <stdlib.h>     
#endif 
#include <aspack.h>
#ifdef ASWANASSERT
typedef int ASWCHANNEL;
#endif
#ifdef ASWANDEBUG
#define MAX_CHANNELMAP        8   
#define MAX_CHANNELNBR        (MAX_CHANNELMAP * 8 * sizeof(m_ulChannelMap[0]))
#define MAX_DEBUGDEVICES      10
#define MAX_IDSTRING          256
#define MAX_DEBUGOUTPUTBUFFER 512
class ASWPUBCLASS CAswChannelMap : public CAswMemoryBase
{
public:
   inline CAswChannelMap()     
   {
      SetChannel(CH_ALLCHANNELS, FALSE);     
   }
   BOOL ASWPUBMETHOD AnyMatchingChannels( CAswChannelMap *OtherMap );
   void ASWPUBMETHOD SetChannel( ASWCHANNEL channel, BOOL bSet );
   inline void SetChannels(  
      ASWCHANNEL c1=CH_UNUSED,   ASWCHANNEL c2=CH_UNUSED,   
      ASWCHANNEL c3=CH_UNUSED,   ASWCHANNEL c4=CH_UNUSED,   
      ASWCHANNEL c5=CH_UNUSED,   ASWCHANNEL c6=CH_UNUSED, 
      ASWCHANNEL c7=CH_UNUSED,   ASWCHANNEL c8=CH_UNUSED,   
      ASWCHANNEL c9=CH_UNUSED,   ASWCHANNEL c10=CH_UNUSED,  
      ASWCHANNEL c11=CH_UNUSED,  ASWCHANNEL c12=CH_UNUSED)
   {
      SetChannel(c1,TRUE);    SetChannel(c2,TRUE);    SetChannel(c3,TRUE);
      SetChannel(c4,TRUE);    SetChannel(c5,TRUE);    SetChannel(c6,TRUE);
      SetChannel(c7,TRUE);    SetChannel(c8,TRUE);    SetChannel(c9,TRUE);
      SetChannel(c10,TRUE);   SetChannel(c11,TRUE);   SetChannel(c12,TRUE);
   }
   inline void ClearChannels(   
      ASWCHANNEL c1=CH_UNUSED,   ASWCHANNEL c2=CH_UNUSED,   
      ASWCHANNEL c3=CH_UNUSED,   ASWCHANNEL c4=CH_UNUSED,   
      ASWCHANNEL c5=CH_UNUSED,   ASWCHANNEL c6=CH_UNUSED, 
      ASWCHANNEL c7=CH_UNUSED,   ASWCHANNEL c8=CH_UNUSED,   
      ASWCHANNEL c9=CH_UNUSED,   ASWCHANNEL c10=CH_UNUSED,  
      ASWCHANNEL c11=CH_UNUSED,  ASWCHANNEL c12=CH_UNUSED)
   {
      SetChannel(c1,FALSE);   SetChannel(c2,FALSE);   SetChannel(c3,FALSE);
      SetChannel(c4,FALSE);   SetChannel(c5,FALSE);   SetChannel(c6,FALSE);
      SetChannel(c7,FALSE);   SetChannel(c8,FALSE);   SetChannel(c9,FALSE);
      SetChannel(c10,FALSE);  SetChannel(c11,FALSE);  SetChannel(c12,FALSE);
   }
private:
   unsigned long m_ulChannelMap[ MAX_CHANNELMAP ];
};
class ASWPUBCLASS CAswDebugOut : public CAswChannelMap
{
public:
   ASWPUBMETHOD CAswDebugOut( void );
   ASWPUBMETHOD ~CAswDebugOut( void );
   inline void SetPControl( PASWCONTROL pControl )
   {
      m_pControl = pControl;
   }
   virtual void ASWPUBMETHOD WriteBuffer( LPSTR lpszString, int iCount ) PURE;
   virtual BOOL ASWPUBMETHOD SetFlushOnWrite( BOOL fFlushOnWrite );
   virtual void ASWPUBMETHOD WriteBanner( void );
private:
   PASWCONTROL m_pControl;
};
class ASWPUBCLASS CAswDebugToMonitor : public CAswDebugOut
{
public:
   inline CAswDebugToMonitor( void )
   {
#ifdef __DEBUG_ALLOC__
  printf("CAswDebugToMonitor() \n"); _heap_check();
#endif
      WriteBanner();
#ifdef __DEBUG_ALLOC__
  printf("CAswDebugToMonitor() ! \n"); _heap_check();
#endif
   }
   virtual void ASWPUBMETHOD WriteBuffer( LPSTR lpszString, int iCount );
};
class ASWPUBCLASS CAswDebugToMsgBox : public CAswDebugOut
{
public:
   virtual void ASWPUBMETHOD WriteBuffer( LPSTR lpszString, int iCount );
};
class ASWPUBCLASS CAswDebugToAssertDialog : public CAswDebugOut
{
public:
   ASWPUBMETHOD CAswDebugToAssertDialog( PASWCONTROL pControl );
   virtual void ASWPUBMETHOD WriteBuffer( LPSTR lpszString, int iCount );
private:
   PASWCONTROL m_pControl;
};
class ASWPUBCLASS CAswDebugToFile : public CAswDebugOut
{
public:
   ASWPUBMETHOD CAswDebugToFile( LPCSTR lpszFilename );
   inline ~CAswDebugToFile()
   {
      CloseFile();                     
   }
   inline void CloseFile( void )
   {
      if ( m_hFile != HFILE_ERROR )
      {
         ::_lclose( m_hFile );
         m_hFile = HFILE_ERROR;
      }
   }
   virtual void ASWPUBMETHOD WriteBuffer( LPSTR lpszString, int iCount );
   virtual BOOL ASWPUBMETHOD SetFlushOnWrite( BOOL fFlushOnWrite );
private:
   HFILE    m_hFile;
   OFSTRUCT m_of;
   BOOL     m_fFlushOnWrite;
   BOOL     m_bAssertShown;
};
class ASWPUBCLASS CAswDebugToBreakpoint : public CAswDebugOut
{
public:
   CAswDebugToBreakpoint( void )
      : CAswDebugOut()  
   {
   }
   virtual void ASWPUBMETHOD WriteBuffer( LPSTR lpszString, int iCount );
};
#endif 
#include <aspop.h>
#endif   
