/* NOSHIP */
/*****************************************************************************
 *
 * Source Module: asintf.i
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Purpose:         List of OLE2 interfaces supported in the Aswan toolkit. This 
 *                      list is be used for two of types of code generation tasks:
 *
 *                      1. It is used for generating the Aswan-wrappered OLE 
 *                          Interface classes that manage the IUnknown interface 
 *                          methods for the user (ie, ABCs for COM). 
 *
 *                      2. It is used for generating debug strings giving the names 
 *                          of the interface depending on the IID.
 *
 *  Notes:          This include file is *NOT* protected from multiple inclusions,
 *                      and should not be, because it may be invoked with different
 *                      definitions of the INTERFACE* macros within the same 
 *                      compilation, to accomplish more than one code generation task.
 *                      For example, see asintbas.cpp, which depends on including
 *                      this file twice to build properly.
 *
 *****************************************************************************/

UNSUPPORTED_INTERFACE( IUnknown,                                  0x00000000L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IClassFactory,                                        0x00000001L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IMalloc,                                              0x00000002L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IMarshal,                                             0x00000003L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IStdMarshalInfo,                                      0x00000018L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IMessageFilter,                                       0x00000016L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IExternalConnection,                                  0x00000019L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IEnumString,                                          0x00000101L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IEnumUnknown,                                         0x00000100L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  ITypeLib,                                             0x00020402L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  ITypeInfo,                                            0x00020401L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  ITypeComp,                                            0x00020403L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IEnumVARIANT,                                         0x00020404L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  ICreateTypeInfo,                                      0x00020405L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  ICreateTypeLib,                                       0x00020406L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IDispatch,                                            0x00020400L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IEnumFORMATETC,                                       0x00000103L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IEnumSTATDATA,                                        0x00000105L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IDataObject,                                          0x0000010eL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IViewObject,                                          0x0000010dL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE2( IViewObject2, IViewObject,                            0x00000127L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IAdviseSink,                                          0x0000010fL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE2( IAdviseSink2, IAdviseSink,                            0x00000125L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IDataAdviseHolder,                                    0x00000110L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IOleCache,                                            0x0000011eL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE2( IOleCache2, IOleCache,                                0x00000128L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IOleCacheControl,                                     0x00000129L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IBindCtx,                                             0x0000000eL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE3( IMoniker, IPersistStream, IPersist,                   0x0000000fL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IRunningObjectTable,                                  0x00000010L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IEnumMoniker,                                         0x00000102L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IDropTarget,                                          0x00000122L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IDropSource,                                          0x00000121L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IPersist,                                             0x0000010cL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE2( IPersistStorage, IPersist,                            0x0000010aL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE2( IPersistStream, IPersist,                             0x00000109L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE2( IPersistFile, IPersist,                               0x0000010bL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IEnumOLEVERB,                                         0x00000104L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IOleObject,                                           0x00000112L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IOleClientSite,                                       0x00000118L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IRunnableObject,                                      0x00000126L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IParseDisplayName,                                    0x0000011aL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE2( IOleContainer, IParseDisplayName,                     0x0000011bL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE3( IOleItemContainer, IOleContainer, IParseDisplayName,  0x0000011cL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IOleAdviseHolder,                                     0x00000111L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IOleLink,                                             0x0000011dL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IOleWindow,                                           0x00000114L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE2( IOleInPlaceObject, IOleWindow,                        0x00000113L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE2( IOleInPlaceActiveObject, IOleWindow,                  0x00000117L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE2( IOleInPlaceUIWindow, IOleWindow,                      0x00000115L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE3( IOleInPlaceFrame, IOleInPlaceUIWindow, IOleWindow,    0x00000116L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE2( IOleInPlaceSite, IOleWindow,                          0x00000119L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IEnumSTATSTG,                                         0x0000000dL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  ILockBytes,                                           0x0000000aL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IStream,                                              0x0000000cL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IStorage,                                             0x0000000bL, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IRootStorage,                                         0x00000012L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
#if defined (_WIN32)
#if !defined(__IBMCPP__)
INTERFACE(  IRichEditOle,                                         0x00020D00L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
INTERFACE(  IRichEditOleCallback,                                 0x00020D03L, 0, 0, 0xC0, 0, 0, 0, 0, 0, 0, 0x46 )
#endif
#endif
LOTUS_INTERFACE( IOleUILinkContainer )
LOTUS_INTERFACE( IOleUILtsLinkContainer )
