/* NOSHIP */
/*****************************************************************************
 *
 *  Name:   aspropcl.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 *  Definition and implementation of classes:
 *
 *    CAswProperties    - holds a set of boolean properties
 *
 *    CAswStdProperties - holds a set of standard Aswan boolean
 *                        properties
 *
 *****************************************************************************/

#ifndef ASPROPCL_H
#define ASPROPCL_H
#include <aspack.h>
typedef WORD ASWPROPERTIESTYPE;
#define ASWPROP_1   ((ASWPROPERTIESTYPE) 0x0001)
#define ASWPROP_2   ((ASWPROPERTIESTYPE) 0x0002)
#define ASWPROP_3   ((ASWPROPERTIESTYPE) 0x0004)
#define ASWPROP_4   ((ASWPROPERTIESTYPE) 0x0008)
#define ASWPROP_5   ((ASWPROPERTIESTYPE) 0x0010)
#define ASWPROP_6   ((ASWPROPERTIESTYPE) 0x0020)
#define ASWPROP_7   ((ASWPROPERTIESTYPE) 0x0040)
#define ASWPROP_8   ((ASWPROPERTIESTYPE) 0x0080)
#define ASWPROP_9   ((ASWPROPERTIESTYPE) 0x0100)
#define ASWPROP_10  ((ASWPROPERTIESTYPE) 0x0200)
#define ASWPROP_11  ((ASWPROPERTIESTYPE) 0x0400)
#define ASWPROP_12  ((ASWPROPERTIESTYPE) 0x0800)
#define ASWPROP_13  ((ASWPROPERTIESTYPE) 0x1000)
#define ASWPROP_14  ((ASWPROPERTIESTYPE) 0x2000)
#define ASWPROP_15  ((ASWPROPERTIESTYPE) 0x4000)
#define ASWPROP_16  ((ASWPROPERTIESTYPE) 0x8000)
#define ASWPROPOnShutdownList ASWPROP_1
#define ASWPROPNeedsShutdown ASWPROP_2
#define ASWPROPSetup     ASWPROP_3
#define ASWPROPUSER_1   ASWPROP_5
#define ASWPROPUSER_2   ASWPROP_6
#define ASWPROPUSER_3   ASWPROP_7
#define ASWPROPUSER_4   ASWPROP_8
#define ASWPROPUSER_5   ASWPROP_9
#define ASWPROPUSER_6   ASWPROP_10
#define ASWPROPUSER_7   ASWPROP_11
#define ASWPROPUSER_8   ASWPROP_12
#define ASWPROPUSER_9   ASWPROP_13
#define ASWPROPUSER_10  ASWPROP_14
#define ASWPROPUSER_11  ASWPROP_15
#define ASWPROPUSER_12  ASWPROP_16
#define ASW_DEFAULT_STDPROP_NAME AswStdProps
#define ASW_DEFAULT_STDPROP_MEMBER m_AswStdProps
#define ONSHUTDOWNLISTPROP( m, bYes ) (##m).SetProperty( ASWPROPOnShutdownList, bYes )
#define ONSHUTDOWNLISTPROP_P( p, bYes ) (##p)->SetProperty( ASWPROPOnShutdownList, bYes )
#define ONSHUTDOWNLIST( bYes ) ONSHUTDOWNLISTPROP( ASW_DEFAULT_STDPROP_MEMBER, bYes )
#define ISONSHUTDOWNLISTPROP(m) (##m).GetProperty( ASWPROPOnShutdownList )
#define ISONSHUTDOWNLISTPROP_P(p) (##p)->GetProperty( ASWPROPOnShutdownList )
#define ISONSHUTDOWNLIST() ISONSHUTDOWNLISTPROP(ASW_DEFAULT_STDPROP_MEMBER)
#define SETUPPROP( m, bYes ) (##m).SetProperty( ASWPROPSetup, bYes )
#define SETUPPROP_P( p, bYes ) (##p)->SetProperty( ASWPROPSetup, bYes )
#define SETUP( bYes ) SETUPPROP( ASW_DEFAULT_STDPROP_MEMBER, bYes )
#define ISSETUPPROP(m) (##m).GetProperty( ASWPROPSetup )
#define ISSETUPPROP_P(p) (##p)->GetProperty( ASWPROPSetup )
#define ISSETUP() ISSETUPPROP(ASW_DEFAULT_STDPROP_MEMBER)
#define NEEDSSHUTDOWNPROP( m, bYes ) (##m).SetProperty( ASWPROPNeedsShutdown, bYes )
#define NEEDSSHUTDOWNPROP_P( p, bYes ) (##p)->SetProperty( ASWPROPNeedsShutdown, bYes )
#define NEEDSSHUTDOWN( bYes ) NEEDSSHUTDOWNPROP( ASW_DEFAULT_STDPROP_MEMBER, bYes )
#define ISNEEDSSHUTDOWNPROP(m) (##m).GetProperty( ASWPROPNeedsShutdown )
#define ISNEEDSSHUTDOWNPROP_P(p) (##p)->GetProperty( ASWPROPNeedsShutdown )
#define ISNEEDSSHUTDOWN() ISNEEDSSHUTDOWNPROP(ASW_DEFAULT_STDPROP_MEMBER)
class ASWPUBCLASS CAswProperties : public CAswMemoryBase
{
public:
   inline CAswProperties( void )
   {
       m_PropertiesBits = 0;
   }
   inline void SetPropertyTrue( ASWPROPERTIESTYPE AswPropID )
   {
      m_PropertiesBits |= AswPropID;
   }
   inline void SetPropertyFalse( ASWPROPERTIESTYPE AswPropID )
   {
      m_PropertiesBits &= ~AswPropID;
   };
   inline void SetProperty( ASWPROPERTIESTYPE AswPropID, BOOL bOn )
   {
      if ( bOn )
         SetPropertyTrue( AswPropID );
      else
         SetPropertyFalse( AswPropID );
   }
   inline BOOL GetProperty( ASWPROPERTIESTYPE AswPropID )
   {
       return ( ( m_PropertiesBits & AswPropID ) ? TRUE : FALSE );
   }
private:
   ASWPROPERTIESTYPE     m_PropertiesBits;
   CAswProperties( const CAswProperties & SourceObject );
   void operator= ( const CAswProperties & SourceObject );
};
class ASWPUBCLASS CAswStdProperties : public CAswProperties
{
public:
    inline CAswStdProperties( void )
    {
        SETUPPROP_P( this, FALSE );
        ONSHUTDOWNLISTPROP_P( this, FALSE );
        NEEDSSHUTDOWNPROP_P( this, FALSE );
    }
private:
    CAswStdProperties( const CAswStdProperties & SourceObject );
    void operator= ( const CAswStdProperties & SourceObject );
};
#define DECLARE_ASW_PROPERTIES_MEMBER( name ) CAswProperties m_##name
#define DECLARE_ASW_STDPROPERTIES_MEMBER( name ) CAswStdProperties m_##name
#define DECLARE_ASW_DEFAULT_STDPROPERTIES_MEMBER() CAswStdProperties ASW_DEFAULT_STDPROP_MEMBER
#define SETSTDPROP(member,userprop,boolval)  (member).SetProperty(userprop,boolval)
#define SETDEFAULTSTDPROP(userprop,boolval)  SETSTDPROP(ASW_DEFAULT_STDPROP_MEMBER,userprop,boolval)
#define SETSTDPROPTRUE(member,userprop)      (member).SetPropertyTrue(userprop)
#define SETDEFAULTSTDPROPTRUE(userprop)      SETSTDPROPTRUE(ASW_DEFAULT_STDPROP_MEMBER,userprop)
#define SETSTDPROPFALSE(member,userprop)     (member).SetPropertyFalse(userprop)
#define SETDEFAULTSTDPROPFALSE(userprop)     SETSTDPROPFALSE(ASW_DEFAULT_STDPROP_MEMBER,userprop)
#define GETSTDPROP(member,userprop)          (member).GetProperty(userprop)
#define GETDEFAULTSTDPROP(userprop)          GETSTDPROP(ASW_DEFAULT_STDPROP_MEMBER,userprop)
#include <aspop.h>
#endif 
