/* NOSHIP */
/*****************************************************************************
 *
 * asstg.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * LIST OF CLASSES IN THIS FILE
 *      CAswStorage
 *
 * Description:
 *
 *
 *
 *****************************************************************************/

#if !defined( ASWAN_STORAGE_H )
#define ASWAN_STORAGE_H
#if defined (_WIN32)
   #include <objbase.h>
#else
   #include <storage.h>
#endif
#include <aspack.h>
class ASWPUBCLASS CAswStorage : public CAswCtlBase
{
public:
   ASWPUBMETHOD CAswStorage( PASWCONTROL pControl );
   ASWPUBMETHOD ~CAswStorage( void );
   CAswResult ASWPUBMETHOD Setup( void );
   CAswResult ASWPUBMETHOD Shutdown( BOOL fEmergency = FALSE );
   LPASWCOLESTR ASWPUBMETHOD GetStorageName( void );
   CAswResult ASWPUBMETHOD SetStorageName( LPASWCOLESTR lpszStorageName );
   CAswResult ASWPUBMETHOD CreateChildStorage( PASWSTORAGE  pAswStorage,
                                               LPASWCOLESTR lpszStorageName,
                                               DWORD        dwgrfMode = STGM_DIRECT |
                                                                        STGM_READ |
                                                                        STGM_FAILIFTHERE,
                                               DWORD        dwReserved1 = 0L,
                                               DWORD        dwReserved2 = 0L );
   CAswResult ASWPUBMETHOD OpenChildStorage( PASWSTORAGE  pAswStorage,
                                             LPASWCOLESTR lpszStorageName,
                                             DWORD        dwgrfMode = STGM_DIRECT | STGM_READ,
                                             DWORD        dwReserved = 0L,
                                             PASWSTORAGE  pAswStoragePriority = NULL,
                                             ASWSNB       snbExclude   = NULL );
   CAswResult ASWPUBMETHOD CreateChildStream( PASWSTREAM   pAswStream,
                                              LPASWCOLESTR lpszStreamName,
                                              DWORD        dwgrfMode = STGM_DIRECT |
                                                                       STGM_READ |
                                                                       STGM_FAILIFTHERE,
                                              DWORD        dwReserved1 = 0L,
                                              DWORD        dwReserved2 = 0L );
   CAswResult ASWPUBMETHOD OpenChildStream( PASWSTREAM   pAswStream,
                                            LPASWCOLESTR lpszStreamName,
                                            DWORD        dwgrfMode = STGM_DIRECT | STGM_READ,
                                            LPVOID       lpReserved1 = NULL,
                                            DWORD        dwReserved2 = 0L);
   CAswResult ASWPUBMETHOD CopyTo( PASWSTORAGE   pAswStgDest,
                                   DWORD         ciidExclude  = 0L,
                                   IID ASWPTR  * rgiidExclude = NULL,
                                   ASWSNB        snbExclude   = NULL );
   CAswResult ASWPUBMETHOD CopyFromAswStorage( PASWSTORAGE pNewAswStg );
   CAswResult ASWPUBMETHOD Commit( DWORD dwCommitFlags = STGC_DEFAULT );
   CAswResult ASWPUBMETHOD Revert( void );
   CAswResult 
   ASWPUBMETHOD EnumElements( LPENUMSTATSTG  ASWPTR * lplpEnumStatStg,
                              DWORD                   dwReserved1 = 0L,
                              LPVOID                  lpReserved2 = NULL,
                              DWORD                   dwReserved3 = 0L );
   CAswResult 
   ASWPUBMETHOD MoveElementTo( LPASWCOLESTR lpszName,
                               PASWSTORAGE  pAswStgDest,
                               LPASWCOLESTR lpszNewName,
                               DWORD        dwgrfFlags = STGMOVE_MOVE );
   CAswResult ASWPUBMETHOD DestroyElement( PASWSTORAGE pAswDelStg );
   CAswResult ASWPUBMETHOD DestroyElement( PASWSTREAM  pAswDelStream );
   CAswResult ASWPUBMETHOD DestroyElement( LPASWCOLESTR pwcsName );
   CAswResult ASWPUBMETHOD RenameElement( LPASWCOLESTR pwcsOldName,
                                          LPASWCOLESTR pwcsNewName );
   CAswResult ASWPUBMETHOD SetElementTimes( LPASWCOLESTR lpszName,
                                            LPFILETIME   pctime,
                                            LPFILETIME   patime,
                                            LPFILETIME   pmtime );
   CAswResult ASWPUBMETHOD SetClass( REFCLSID clsid );
   CAswResult ASWPUBMETHOD GetClass( LPCLSID lpclsid );
   CAswResult ASWPUBMETHOD Stat( PASWSTATSTG pAswStatstg );
   CAswResult 
   ASWPUBMETHOD ConvertAswStorageToOLE1STREAM( LPOLESTREAM lpOleStream );
   CAswResult 
   ASWPUBMETHOD ConvertOLE1STREAMToAswStorage( LPOLESTREAM      lpOleStream,
                                               LPDVTARGETDEVICE ptd );
   CAswResult 
   ASWPUBMETHOD CreateStorageOnHGlobal( HGLOBAL hGlobal, 
                                        BOOL    fDeleteOnRelease = TRUE,
                                        DWORD   dwgrfMode =   STGM_DIRECT 
                                                            | STGM_READWRITE );
   CAswResult ASWPUBMETHOD GetHGlobalFromStorage( HGLOBAL ASWPTR * phGlobal );
   CAswResult 
   ASWPUBMETHOD ReadFmtUserType( LPCLIPFORMAT  lpcf, 
                                 LPASWOLESTR ASWPTR * lplpszUserType );
   CAswResult ASWPUBMETHOD WriteFmtUserType( CLIPFORMAT  cf, 
                                             LPASWOLESTR lpszUserType );
   virtual CAswResult 
   ASWPUBMETHOD GetRefHolder( PPASWREFHOLDER ppRefHolder );
   CAswResult 
   ASWPUBMETHOD GetRefHolderLockBytes( PPASWREFHOLDER ppRefHolder );
   virtual ASWREFIID ASWPUBMETHOD GetPreferredIID( void );
   inline LPSTORAGE GetRealStorage( void )
   {
      return ( GetLPStorage() );
   }
   CAswResult ASWPUBMETHOD SetReturnedStorage( LPSTORAGE lpStorage );
   CAswResult ASWPUBMETHOD SetGivenStorage( LPSTORAGE lpStorage );
   inline void SetParentStorage( PASWSTORAGE pParentStg )
   {
      ASWMETHOD( "SetParentStorage", (CH_CLASS_ASSTORAGE) );
      ASWENTRYF("pParentStg = %p", (ASWSTR, pParentStg) );
      m_pParentStg = pParentStg;
      ASWEXIT();
   }
   inline PASWSTORAGE GetParentStorage( void )
   {
      ASWMETHOD( "GetParentStorage", (CH_CLASS_ASSTORAGE) );
      ASWENTRY();
      ASWEXITF( m_pParentStg, "Returns PASWSTORAGE %p", 
                (ASWSTR, m_pParentStg ) );
   }
   inline LPLOCKBYTES GetRealLockBytes( void )
   {
      return ( GetLPLockBytes() );
   }
private:
   inline LPSTORAGE GetLPStorage( void )
   {
      return( (LPSTORAGE) m_RefHolderStorage.Get() );
   }
   inline LPLOCKBYTES GetLPLockBytes( void )
   {
      return( (LPLOCKBYTES) m_RefHolderLockBytes.Get() );
   }
   static BOOL IsEmpty( const PASWSTORAGE pAswStorage );
   static BOOL IsEmpty( const PASWSTREAM  pAswStream );
   CAswOLEString  m_StorageName;
   BOOL           m_fSetup;
   CAswRefHolder  m_RefHolderStorage;
   CAswRefHolder  m_RefHolderLockBytes;
   PASWSTORAGE    m_pParentStg;
};
inline 
void CAswSmartOLEString::Deallocate( void )
{
   if (   (NULL != m_OLEPtr)
       && (STATFLAG_DEFAULT == m_dwStatFlags) )
   {
      ::OleStdFree( (LPVOID) m_OLEPtr );
   }
   m_OLEPtr = NULL;
}
inline 
void CAswSmartOLEString::Allocate( DWORD dwLen )
{
   Deallocate();
   m_dwStatFlags = STATFLAG_DEFAULT;
   m_OLEPtr = (LPASWOLESTR) ::OleStdMalloc( dwLen );
   ASWGLOBALASSERT_WPTROK( m_OLEPtr );
}
#include <aspop.h>
#endif      
