/* NOSHIP */
/*****************************************************************************
 *
 * astypes.h
 *
 * (C) Copyright Lotus Development Coporation 1994, 1996. All Rights Reserved.
 *
 * Aswan common types - master set of typedefs for every common type
 *                       in Aswan.
 *
 * NEEDSWORK:
 *
 *  1) A class XXX statement should be in this file for almost
 *     every Aswan type, so that forward reference problems
 *     on pointers are avoided in other places.
 *
 *****************************************************************************/

#ifndef ASTYPES_H
#define ASTYPES_H
#if defined (_WIN32) && !defined (LTSOS2)  
extern "C" BOOL WINAPI _CRT_INIT (HINSTANCE hInstDLL, DWORD fdwReason,
                                  LPVOID lpReserved);
#endif
#define ARRAYELEMENTS(A) (sizeof(A)/sizeof((A)[0]))
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif
#define REFERENCE(PARAM) (PARAM=PARAM)
#if defined( ASWANASSERT )
#define ASWAN_CROSSCHECK(v)  (v).CrossCheck();
#define ASWAN_CROSSCHECKP(p) (p)->CrossCheck();
#else
#define ASWAN_CROSSCHECK(v)
#define ASWAN_CROSSCHECKP(p)
#endif
#if defined(_WIN32)
   #define ASWCODESEGSTRING(variable, string)   \
      const char * variable = string
   #define ASWSTATICCODESEGSTRING(variable, string)   \
      static const char * variable = string
#else
#if defined(MAKEDLL)
   #define ASWCODESEGSTRING(variable, string)   \
      const char * variable = string
   #define ASWSTATICCODESEGSTRING(variable, string)   \
      static const char * variable = string
#else
   #define ASWCODESEGSTRING(variable, string)   \
      static const char __based(__segname("ASWSTR_TEXT")) variable [] = string
   #define ASWSTATICCODESEGSTRING(variable, string)   \
      ASWCODESEGSTRING(variable,string)
#endif 
#endif 
#if defined(_WIN32)
   #define ASWNAMEDCODESEGSTRING(segname, variable, string)   \
             char variable [] = string
#else
   #if defined(MAKEDLL)
      #define ASWNAMEDCODESEGSTRING(segname, variable, string)   \
                char * variable = string
   #else
      #define ASWNAMEDCODESEGSTRING(segname, variable, string)   \
         static char __based(__segname(segname)) variable [] = string
   #endif 
#endif 
#if defined(_WIN32)
   #if defined(ASWDLL)
      #if defined(MAKEDLL)
         #define ASWEXTRNCODESEGSTRING(variable, string) char variable [] = string
         #define REFASWEXTRNCODESEGSTRING(variable, string) extern char variable [];
      #else
         #define ASWEXTRNCODESEGSTRING(variable, string) char variable [] = string
         #define REFASWEXTRNCODESEGSTRING(variable, string) ASWEXTRNCODESEGSTRING(variable, string)
      #endif
   #else
      #define ASWEXTRNCODESEGSTRING(variable, string) char variable [] = string
      #define REFASWEXTRNCODESEGSTRING(variable, string) extern char variable [];
   #endif
#else
   #if defined(ASWDLL)
      #if defined(MAKEDLL)
         #define ASWEXTRNCODESEGSTRING(variable, string) \
            char NEAR * variable = string
         #define REFASWEXTRNCODESEGSTRING(variable, string) \
            extern char NEAR * variable
      #else
         #define ASWEXTRNCODESEGSTRING(variable, string) \
            static char __based(__segname("ASWXTRN_TEXT")) variable [] = string
         #define REFASWEXTRNCODESEGSTRING(variable, string) \
            ASWEXTRNCODESEGSTRING(variable, string)
      #endif
   #else
      #define ASWEXTRNCODESEGSTRING(variable, string) \
         char __based(__segname("ASWXTRN_TEXT")) variable [] = string
      #define REFASWEXTRNCODESEGSTRING(variable,string) \
         extern char __based(__segname("ASWXTRN_TEXT")) variable [];
   #endif
#endif 
FORWARD_CLASS_REF( CAswAsync,           ASYNC );
FORWARD_CLASS_REF( CAswControl,         CONTROL );
FORWARD_CLASS_REF( CAswCOMBase,         COMBASE );
FORWARD_CLASS_REF( CAswBase,            BASE );
FORWARD_CLASS_REF( CAswDebugBase,       DEBUGBASE );
FORWARD_CLASS_REF( CAswShutdown,        SHUTDOWN );
FORWARD_CLASS_REF( CAswCtlBase,         CTLBASE );
FORWARD_CLASS_REF( CAswListEl,          LISTEL );
FORWARD_CLASS_REF( CAswListHead,        LISTHEAD );
FORWARD_CLASS_REF( CAswProperties,      PROPERTIES );
FORWARD_CLASS_REF( CAswDebugOut,        DEBUGOUT );
FORWARD_CLASS_REF( CAswMalloc,          MALLOC );
FORWARD_CLASS_REF( CAswStringBase,      STRINGBASE );
FORWARD_CLASS_REF( CAswANSIString,      ANSISTRING );
FORWARD_CLASS_REF( CAswOLEString,       OLESTRING );
FORWARD_CLASS_REF( CAswRefHolder,       REFHOLDER );
FORWARD_CLASS_REF( CAswAsync,           ASYNC );
FORWARD_CLASS_REF( CAswAsyncObject,     ASYNCOBJECT );
FORWARD_CLASS_REF( CAswANSIString,      ANSISTRING );
FORWARD_CLASS_REF( CAswOLEString,       OLESTRING );
#if defined(ASWANASSERT)
FORWARD_CLASS_REF( CAswBoolRegValue,    BOOLREGVALUE );
#endif
#if defined( ASWOCX )
FORWARD_CLASS_REF( CAswConnMgr,         CONNMGR );
FORWARD_CLASS_REF( CAswAutoConnMgr,     AUTOCONNMGR );
FORWARD_CLASS_REF( CAswEventSink,       EVENTSINK );
#endif
#include <astserv.h>             
#include <astdobj.h>             
#include <aststorg.h>            
#include <astcont.h>             
#endif 
