/* NOSHIP */

/*******************************************************************************
 *
 * asole2ui.h
 *
 * Copyright (c)1992,1995 Microsoft Corporation, All Rights Reserved
 *              (contains IDS_xxx definitions derived from OLESTD.H) 
 *              (contains ID_xxx  definitions derived from OLEDLG.H)
 * Copyright (c)1995,1996 Lotus Development Corporation. All Rights Reserved.
 *
 * Description:
 *    Published definitions, structures, types, and function prototypes for the
 *    OLE 2.0 User Interface support library.
 *
*******************************************************************************/

#ifndef _ASOLE2UI_H_
#define _ASOLE2UI_H_
#if !defined(APSTUDIO_INVOKED) || defined(WIN16)
#ifdef __cplusplus
extern "C" {
#endif
#if !defined(__cplusplus) && !defined( __TURBOC__)
#define NONAMELESSUNION     
#endif
#ifndef _WINDOWS_
#include <windows.h>
#endif
#if     ( _MSC_VER >= 800 )
#pragma warning(disable:4001)
#endif
#ifndef _INC_SHELLAPI_
#include <shellapi.h>
#endif
#ifndef _OLE2_H_
#include <ole2.h>
#endif
#include <string.h>
#include <dlgs.h>           
#if DBG
#include <assert.h>
#define FnAssert(lpstrExpr, lpstrMsg, lpstrFileName, iLine)     \
        (_assert(lpstrMsg ? lpstrMsg : lpstrExpr,               \
                 lpstrFileName,                                 \
                 iLine), NOERROR)
#endif 
#if defined(_WIN32) && !defined(LTSOS2)
   typedef WCHAR ASWOLECHAR;
   typedef  ASWOLECHAR __RPC_FAR *LPASWOLESTR;
   typedef  const ASWOLECHAR __RPC_FAR *LPASWCOLESTR;
   typedef  ASWOLECHAR __RPC_FAR *__RPC_FAR *ASWSNB;  
   #define ASWOLESTR(str) L##str
#else
   typedef char ASWOLECHAR;
   typedef ASWOLECHAR FAR* LPASWOLESTR;
   typedef const ASWOLECHAR FAR* LPASWCOLESTR;
   #define ASWOLESTR(str) str
   #define  ASWSNB SNB   
#endif
#if !defined( EXPORT )
   #ifdef WIN32
      #if defined(MAKEDLL)
         #define EXPORT __declspec (dllexport)
      #else
         #define EXPORT 
      #endif
   #else 
      #define EXPORT  __export
   #endif  
#endif  
#if !defined( STDEXPORT )
   #if defined(WIN32) && defined(MAKEDLL)
      #define STDEXPORT __declspec (dllexport)
   #else 
      #define STDEXPORT
   #endif  
#endif  
#else 
#include <winuser.h>
#include <dlgs.h>
#endif 
#include "asolestd.h"
#ifdef __TURBOC__
#define _getcwd getcwd
#define _itoa   itoa
#define __max   max
#define _find_t find_t
#endif 
#ifdef LTSOS2
#define __max max
#endif
#ifdef WIN32
#if !defined(LTSOS2)
#define _fmemset memset
#define _fmemcpy memcpy
#define _fmemcmp memcmp
#define _fstrcpy strcpy
#define _fstrncpy strncpy
#define _fstrlen strlen
#define _fstrrchr strrchr
#define _fstrtok strtok
#endif
#if !defined(LTSOS2)
#undef isspace
#define isspace(j) (j==' ' || j=='\t' || j=='\n')
#endif 
#endif  
#include "aserrval.h"
#include <aspack.h>
#if defined(MAKEDLL) &&  defined(__IBMCPP__)  
  #define STDEXPORT_STDAPI extern "C" __declspec (dllexport) HRESULT __stdcall 
#else
  #define STDEXPORT_STDAPI STDEXPORT STDAPI
#endif
#ifndef LPTSTR
typedef TCHAR FAR *LPTSTR;
#endif
#ifndef LPCTSTR
typedef const TCHAR FAR *LPCTSTR;
#endif
STDAPI_(STDEXPORT UINT) OleUISetResourceDLLHandle( HINSTANCE hInstResourceDLL );
#define OleUIUninitialize OleUIUnInitialize
STDAPI_(STDEXPORT UINT) OleUIInitialize(LPCSTR lpszLanguageID);
STDAPI_(STDEXPORT BOOL) OleUIUninitialize(void);
#if !defined( SZCLASSICONBOX )
#define SZCLASSICONBOX  "ole2uiIBCls"
#endif
#if !defined( SZCLASSRESULTIMAGE )
#define SZCLASSRESULTIMAGE  "ole2uiRICls"
#endif
extern DWORD g_dwObjectCount;
STDEXPORT_STDAPI OleUICanUnloadNow(void);
STDEXPORT_STDAPI OleUILockLibrary(BOOL fLock);
#define ID_BROWSEHOOKOFN_CHANGESOURCE     1
#define IDD_LTSMANAGENOUPDATE          32244
#define IDD_LTSMANAGELINKS             32245
#define IDD_LTSCREATEOBJECT            32246
#define IDD_LTSADDTOMENU               32247
#define IDD_INSERTOBJECT               32248
#define IDD_CHANGEICON                 32249
#define IDD_CONVERT                    32250
#define IDD_PASTESPECIAL               32251
#define IDD_EDITLINKS                  32252
#define IDD_FILEOPEN                   32253
#define IDD_BUSY                       32254
#define IDD_UPDATELINKS                32255
#define IDD_CANNOTUPDATELINK           32256
#define IDD_CHANGESOURCE               32257
#define IDD_INSERTFILEBROWSE           32258
#define IDD_CHANGEICONBROWSE           32259
#define IDD_LINKSOURCEUNAVAILABLE      32260
#define IDD_SERVERNOTREG               32261
#define IDD_LINKTYPECHANGED            32262
#define IDD_SERVERNOTFOUND             32263
#define IDD_OUTOFMEMORY                32264
#define IDD_LTSUPDATENOW               32265
#define IDD_LTSLINKSSOURCECHANGE       32266
#define IDD_LTSUNABLETOCREATE          32267
#define IDD_CHANGESOURCE_95            32268
#define IDD_LTSCONFIRMBREAKLINK        32269
#define IDD_CHANGESOURCE_95_NOHELPBTTN 32270
#define IDS_OLE2UIUNKNOWN              32300
#define IDS_OLE2UILINK                 32301
#define IDS_OLE2UIOBJECT               32302
#define IDS_OLE2UIEDIT                 32303
#define IDS_OLE2UICONVERT              32304
#define IDS_OLE2UIEDITLINKCMD_1VERB    32305
#define IDS_OLE2UIEDITOBJECTCMD_1VERB  32306
#define IDS_OLE2UIEDITLINKCMD_NVERB    32307
#define IDS_OLE2UIEDITOBJECTCMD_NVERB  32308
#define IDS_OLE2UIEDITNOOBJCMD         32309
#define IDS_DEFICONLABEL               32310
#define IDS_OLE2UIPASTELINKEDTYPE      32311
#define IDS_CANTUPDATELINK             32315
#define IDS_FILTERS                    32320
#define IDS_ICONFILTERS                32321
#define IDS_BROWSE                     32322
#define IDS_BROK                       32323
#define IDB_RESULTSEGA                 32325
#define IDB_RESULTSVGA                 32326
#define IDB_RESULTSHIRESVGA            32327
#define IDC_MOVE4WAY                   32330
#define IDC_HANDLENESW                 32331
#define IDC_HANDLENS                   32332
#define IDC_HANDLENWSE                 32333
#define IDC_HANDLEWE                   32334
#ifndef PVOID
typedef VOID *PVOID;
#endif
#if !defined(LTSOS2)
   #define CALLBACK_PTR CALLBACK *
#else
   #define CALLBACK_PTR * CALLBACK
#endif
typedef UINT (CALLBACK_PTR LPFNOLEUIHOOK)(HWND, UINT, WPARAM, LPARAM);
#define IDS_ASWDEFAULTVERB0   17408
#define IDS_ASWDEFAULTVERB1   17409
#define IDS_ASWDEFAULTVERB2   17410
#define IDS_ASWDEFAULTVERB3   17411
#define IDS_ASWDEFAULTVERB4   17412
#define IDS_ASWDEFAULTVERB5   17413
#define IDS_ASWDEFAULTVERB6   17414
#define SZOLEUI_MSG_HELP               "OLEUI_MSG_HELP"
#define SZOLEUI_MSG_DIALOGENTRY        "OLEUI_MSG_DIALOGENTRY"
#define SZOLEUI_MSG_DIALOGEXIT         "OLEUI_MSG_DIALOGEXIT"
#define SZOLEUI_MSG_ENDDIALOG          "OLEUI_MSG_ENDDIALOG"
#define SZOLEUI_MSG_BROWSE             "OLEUI_MSG_BROWSE"
#define SZOLEUI_MSG_CHANGEICON         "OLEUI_MSG_CHANGEICON"
#define SZOLEUI_MSG_CLOSEBUSYDIALOG    "OLEUI_MSG_CLOSEBUSYDIALOG"
#define SZOLEUI_MSG_FILEOKSTRING       "OLEUI_MSG_FILEOKSTRING"
#define SZOLEUI_MSG_CHANGESOURCE       "OLEUI_MSG_CHANGESOURCE"
#define SZOLEUI_MSG_BROWSE_OFN         "OLEUI_MSG_BROWSE_OFN"
#define OLEUI_FALSE                     0
#define OLEUI_SUCCESS                   1     
#define OLEUI_OK                        1     
#define OLEUI_CANCEL                    2     
#define OLEUI_ERR_STANDARDMIN           100
#define OLEUI_ERR_STRUCTURENULL         101   
#define OLEUI_ERR_STRUCTUREINVALID      102
#define OLEUI_ERR_CBSTRUCTINCORRECT     103
#define OLEUI_ERR_HWNDOWNERINVALID      104
#define OLEUI_ERR_LPSZCAPTIONINVALID    105
#define OLEUI_ERR_LPFNHOOKINVALID       106
#define OLEUI_ERR_HINSTANCEINVALID      107
#define OLEUI_ERR_LPSZTEMPLATEINVALID   108
#define OLEUI_ERR_HRESOURCEINVALID      109
#define OLEUI_ERR_FINDTEMPLATEFAILURE   110   
#define OLEUI_ERR_LOADTEMPLATEFAILURE   111
#define OLEUI_ERR_DIALOGFAILURE         112
#define OLEUI_ERR_LOCALMEMALLOC         113
#define OLEUI_ERR_GLOBALMEMALLOC        114
#define OLEUI_ERR_LOADSTRING            115
#define OLEUI_ERR_LOADEDUSERLANGUAGE    116
#define OLEUI_ERR_RESOURCELOADFAILURE   117
#define OLEUI_ERR_NOLANGUAGERESOURCE    118
#define OLEUI_ERR_RESINITFAILED         119
#define OLEUI_ERR_LANGUAGEALREADYSET    120
#define OLEUI_ERR_IMALLOCMEMALLOC       121
#define OLEUI_ERR_NOMEMALLOCATOR        122   
#define OLEUI_ERR_LBERR                 123   
#define OLEUI_ERR_STANDARDMAX           200   
#define ID_OLEUIHELP                    99
#undef IDHELP
#define IDHELP  1038
#define  ID_STATIC                      98
#define OLEUI_CCHKEYMAX                 256  
#define OLEUI_CCHVERBMAX                32
#define OLEUI_OBJECTMENUMAX             256
#if defined(WIN32)
#define OLEUI_CCHPATHMAX                MAX_PATH
#else
#define OLEUI_CCHPATHMAX                256 
#endif
#define OLEUI_CCHLABELMAX               39  
#define OLEUI_CCHCLSIDSTRING            39
STDAPI_(STDEXPORT BOOL) OleUIAddVerbMenu(LPOLEOBJECT lpOleObj,
                      LPASWOLESTR lpszShortType,
                      HMENU hMenu,
                      UINT uPos,
                      UINT uIDVerbMin,
                      UINT uIDVerbMax,
                      BOOL bAddConvert,
                      UINT idConvert,
                      HMENU FAR *lphMenu);
STDAPI_(STDEXPORT void)    OleUIMetafilePictIconFree(HGLOBAL);
STDAPI_(STDEXPORT BOOL)    OleUIMetafilePictIconDraw(HDC, LPRECT, HGLOBAL, BOOL);
STDAPI_(STDEXPORT UINT)    OleUIMetafilePictExtractLabel(HGLOBAL, LPASWOLESTR, UINT, LPDWORD);
STDAPI_(STDEXPORT HICON)   OleUIMetafilePictExtractIcon(HGLOBAL);
STDAPI_(STDEXPORT BOOL)    OleUIMetafilePictExtractIconSource(HGLOBAL,LPASWOLESTR,UINT FAR *);
typedef struct tagOLEUILTSATMITEM
{
   CLSID           Clsid;
   ASWOLECHAR      szClass [OLEUI_CCHKEYMAX]; 
} OLEUILTSATMITEM, *POLEUILTSATMITEM, FAR *LPOLEUILTSATMITEM;
typedef struct tagOLEUILTSADDTOMENU
{
   DWORD           cbStruct;       
   DWORD           dwFlags;        
   HWND            hWndOwner;      
   LPASWCOLESTR    lpszCaption;    
   LPFNOLEUIHOOK   lpfnHook;       
   LPARAM          lCustData;      
   HINSTANCE       hInstance;      
   LPASWCOLESTR    lpszTemplate;   
   HRSRC           hResource;      
   UINT                 cClsidExclude;    
   LPCLSID              lpClsidExclude;   
   UINT                 cATMItemChecked;  
   LPOLEUILTSATMITEM    lpATMItemChecked; 
   HWND                 hList;            
} OLEUILTSADDTOMENU, *POLEUILTSADDTOMENU, FAR *LPOLEUILTSADDTOMENU;
STDAPI_(STDEXPORT UINT) OleUILtsAddToMenu(LPOLEUILTSADDTOMENU);
#define ATMF_SHOWHELP                0x00000001L
#define OLEUI_ATMERR_LPCLSIDEXCLUDEINVALID      (OLEUI_ERR_STANDARDMAX+0)
#define OLEUI_ATMERR_LPOLEUILTSATMITEMINVALID   (OLEUI_ERR_STANDARDMAX+1)
#define OLEUI_ATMERR_HLISTINVALID               (OLEUI_ERR_STANDARDMAX+2)
#define ID_ATM_OBJECTTYPELIST          3100
#define ID_ATM_PURPOSE_TEXT            3101
typedef struct tagOLEUIINSERTOBJECT
   {
   DWORD           cbStruct;         
   DWORD           dwFlags;          
   HWND            hWndOwner;        
   LPASWCOLESTR    lpszCaption;      
   LPFNOLEUIHOOK   lpfnHook;         
   LPARAM          lCustData;        
   HINSTANCE       hInstance;        
   LPASWCOLESTR    lpszTemplate;     
   HRSRC           hResource;        
   CLSID           clsid;            
   LPASWOLESTR     lpszFile;         
   UINT            cchFile;          
   UINT            cClsidExclude;    
   LPCLSID         lpClsidExclude;   
   IID             iid;              
   DWORD           oleRender;        
   LPFORMATETC     lpFormatEtc;      
   LPOLECLIENTSITE lpIOleClientSite; 
   LPSTORAGE       lpIStorage;       
   LPVOID FAR     *ppvObj;           
   SCODE           sc;               
   HGLOBAL         hMetaPict;        
   int             nDialogID;        
   } OLEUIINSERTOBJECT, *POLEUIINSERTOBJECT, FAR *LPOLEUIINSERTOBJECT;
STDAPI_(STDEXPORT UINT) OleUIInsertObject(LPOLEUIINSERTOBJECT);
typedef struct tagOLEUILTSCREATEOBJECT
{
   OLEUIINSERTOBJECT    IO;   
   OLEUILTSADDTOMENU    ATM;  
} OLEUILTSCREATEOBJECT, *POLEUILTSCREATEOBJECT, FAR *LPOLEUILTSCREATEOBJECT;
STDAPI_(STDEXPORT UINT) OleUILtsCreateObject (LPOLEUILTSCREATEOBJECT);
#define COF_SHOWHELP                0x00000001L
#define COF_SELECTCREATENEW         0x00000002L
#define COF_SELECTCREATEFROMFILE    0x00000004L
#define COF_CHECKLINK               0x00000008L
#define COF_CHECKDISPLAYASICON      0x00000010L
#define COF_CREATENEWOBJECT         0x00000020L
#define COF_CREATEFILEOBJECT        0x00000040L
#define COF_CREATELINKOBJECT        0x00000080L
#define COF_DISABLELINK             0x00000100L
#define COF_VERIFYSERVERSEXIST      0x00000200L
#define COF_DISABLEDISPLAYASICON    0x00000400L
#define COF_DISABLEADDTOMENU        0x00000800L 
#define IOF_SHOWHELP                COF_SHOWHELP            
#define IOF_SELECTCREATENEW         COF_SELECTCREATENEW     
#define IOF_SELECTCREATEFROMFILE    COF_SELECTCREATEFROMFILE
#define IOF_CHECKLINK               COF_CHECKLINK           
#define IOF_CHECKDISPLAYASICON      COF_CHECKDISPLAYASICON  
#define IOF_CREATENEWOBJECT         COF_CREATENEWOBJECT     
#define IOF_CREATEFILEOBJECT        COF_CREATEFILEOBJECT    
#define IOF_CREATELINKOBJECT        COF_CREATELINKOBJECT    
#define IOF_DISABLELINK             COF_DISABLELINK         
#define IOF_VERIFYSERVERSEXIST      COF_VERIFYSERVERSEXIST  
#define IOF_DISABLEDISPLAYASICON    COF_DISABLEDISPLAYASICON
#define IOF_DISABLEADDTOMENU        COF_DISABLEADDTOMENU    
#define OLEUI_COERR_LPSZFILEINVALID         (OLEUI_ERR_STANDARDMAX+0)
#define OLEUI_COERR_LPSZLABELINVALID        (OLEUI_ERR_STANDARDMAX+1)
#define OLEUI_COERR_HICONINVALID            (OLEUI_ERR_STANDARDMAX+2)
#define OLEUI_COERR_LPFORMATETCINVALID      (OLEUI_ERR_STANDARDMAX+3)
#define OLEUI_COERR_PPVOBJINVALID           (OLEUI_ERR_STANDARDMAX+4)
#define OLEUI_COERR_LPIOLECLIENTSITEINVALID (OLEUI_ERR_STANDARDMAX+5)
#define OLEUI_COERR_LPISTORAGEINVALID       (OLEUI_ERR_STANDARDMAX+6)
#define OLEUI_COERR_SCODEHASERROR           (OLEUI_ERR_STANDARDMAX+7)
#define OLEUI_COERR_LPCLSIDEXCLUDEINVALID   (OLEUI_ERR_STANDARDMAX+8)
#define OLEUI_COERR_CCHFILEINVALID          (OLEUI_ERR_STANDARDMAX+9)
#define OLEUI_IOERR_LPSZFILEINVALID         OLEUI_COERR_LPSZFILEINVALID        
#define OLEUI_IOERR_LPSZLABELINVALID        OLEUI_COERR_LPSZLABELINVALID       
#define OLEUI_IOERR_HICONINVALID            OLEUI_COERR_HICONINVALID           
#define OLEUI_IOERR_LPFORMATETCINVALID      OLEUI_COERR_LPFORMATETCINVALID     
#define OLEUI_IOERR_PPVOBJINVALID           OLEUI_COERR_PPVOBJINVALID          
#define OLEUI_IOERR_LPIOLECLIENTSITEINVALID OLEUI_COERR_LPIOLECLIENTSITEINVALID
#define OLEUI_IOERR_LPISTORAGEINVALID       OLEUI_COERR_LPISTORAGEINVALID      
#define OLEUI_IOERR_SCODEHASERROR           OLEUI_COERR_SCODEHASERROR          
#define OLEUI_IOERR_LPCLSIDEXCLUDEINVALID   OLEUI_COERR_LPCLSIDEXCLUDEINVALID  
#define OLEUI_IOERR_CCHFILEINVALID          OLEUI_COERR_CCHFILEINVALID         
#define ID_IO_CREATENEW                 2100
#define ID_IO_CREATEFROMFILE            2101
#define ID_IO_LINKFILE                  2102
#define ID_IO_OBJECTTYPELIST            2103
#define ID_IO_DISPLAYASICON             2104
#define ID_IO_CHANGEICON                2105
#define ID_IO_FILE                      2106
#define ID_IO_FILEDISPLAY               2107
#define ID_IO_RESULTIMAGE               2108
#define ID_IO_RESULTTEXT                2109
#define ID_IO_ICONDISPLAY               2110
#define ID_IO_OBJECTTYPETEXT            2111
#define ID_IO_FILETEXT                  2112
#define ID_IO_FILETYPE                  2113
#define ID_CO_ADDTOMENU                 2114
#define IDS_IORESULTNEW                 32400
#define IDS_IORESULTNEWICON             32401
#define IDS_IORESULTFROMFILE1           32402
#define IDS_IORESULTFROMFILE2           32403
#define IDS_IORESULTFROMFILEICON2       32404
#define IDS_IORESULTLINKFILE1           32405
#define IDS_IORESULTLINKFILE2           32406
#define IDS_IORESULTLINKFILEICON1       32407
#define IDS_IORESULTLINKFILEICON2       32408
#define     PS_MAXLINKTYPES  8
typedef struct tagOLEUIPASTESPECIAL
   {
   DWORD           cbStruct;       
   DWORD           dwFlags;        
   HWND            hWndOwner;      
   LPASWCOLESTR    lpszCaption;    
   LPFNOLEUIHOOK   lpfnHook;       
   LPARAM          lCustData;      
   HINSTANCE       hInstance;      
   LPASWCOLESTR    lpszTemplate;   
   HRSRC           hResource;      
   LPDATAOBJECT    lpSrcDataObj;       
   LPOLEUIPASTEENTRY arrPasteEntries;  
   int             cPasteEntries;      
   UINT       FAR *arrLinkTypes;      
   int             cLinkTypes;         
   UINT            cClsidExclude;      
   LPCLSID         lpClsidExclude;     
   int             nSelectedIndex;     
   BOOL            fLink;              
   HGLOBAL         hMetaPict;          
   SIZEL           sizel;              
   } OLEUIPASTESPECIAL, *POLEUIPASTESPECIAL, FAR *LPOLEUIPASTESPECIAL;
STDAPI_(STDEXPORT UINT) OleUIPasteSpecial(LPOLEUIPASTESPECIAL);
#define PSF_SHOWHELP                0x00000001L
#define PSF_SELECTPASTE             0x00000002L
#define PSF_SELECTPASTELINK         0x00000004L
#define PSF_CHECKDISPLAYASICON      0x00000008L
#define PSF_DISABLEDISPLAYASICON    0x00000010L
#define OLEUI_IOERR_SRCDATAOBJECTINVALID      (OLEUI_ERR_STANDARDMAX+0)
#define OLEUI_IOERR_ARRPASTEENTRIESINVALID    (OLEUI_ERR_STANDARDMAX+1)
#define OLEUI_IOERR_ARRLINKTYPESINVALID       (OLEUI_ERR_STANDARDMAX+2)
#define OLEUI_PSERR_CLIPBOARDCHANGED          (OLEUI_ERR_STANDARDMAX+3)
#define ID_PS_PASTE                    500
#define ID_PS_PASTELINK                501
#define ID_PS_SOURCETEXT               502
#define ID_PS_PASTELIST                503
#define ID_PS_PASTELINKLIST            504
#define ID_PS_DISPLAYLIST              505
#define ID_PS_DISPLAYASICON            506
#define ID_PS_ICONDISPLAY              507
#define ID_PS_CHANGEICON               508
#define ID_PS_RESULTIMAGE              509
#define ID_PS_RESULTTEXT               510
#define ID_PS_RESULTGROUP              511
#define ID_PS_STXSOURCE                512
#define ID_PS_STXAS                    513
#define IDS_PSPASTEDATA                32410
#define IDS_PSPASTEOBJECT              32411
#define IDS_PSPASTEOBJECTASICON        32412
#define IDS_PSPASTELINKDATA            32413
#define IDS_PSPASTELINKOBJECT          32414
#define IDS_PSPASTELINKOBJECTASICON    32415
#define IDS_PSNONOLE                   32416
#define IDS_PSUNKNOWNTYPE              32417
#define IDS_PSUNKNOWNSRC               32418
#define IDS_PSUNKNOWNAPP               32419
#define LPOLEUILINKCONTAINER     IOleUILinkContainer FAR*
#undef  INTERFACE
#define INTERFACE   IOleUILinkContainer
DECLARE_INTERFACE_(IOleUILinkContainer, IUnknown)
{
   STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
   STDMETHOD_(ULONG,AddRef) (THIS) PURE;
   STDMETHOD_(ULONG,Release) (THIS) PURE;
   STDMETHOD_(DWORD,GetNextLink) (THIS_ DWORD dwLink) PURE;
   STDMETHOD(SetLinkUpdateOptions) (THIS_ DWORD dwLink, DWORD dwUpdateOpt) PURE;
   STDMETHOD(GetLinkUpdateOptions) (THIS_ DWORD dwLink, DWORD FAR* lpdwUpdateOpt) PURE;
   STDMETHOD(SetLinkSource) (THIS_
         DWORD       dwLink,
         LPASWOLESTR lpszDisplayName,
         ULONG       lenFileName,
         ULONG FAR*  pchEaten,
         BOOL        fValidateSource) PURE;
   STDMETHOD(GetLinkSource) (THIS_
         DWORD       dwLink,
         LPASWOLESTR FAR*  lplpszDisplayName,
         ULONG FAR*  lplenFileName,
         LPASWOLESTR FAR*  lplpszFullLinkType,
         LPASWOLESTR FAR*  lplpszShortLinkType,
         BOOL FAR*   lpfSourceAvailable,
         BOOL FAR*   lpfIsSelected) PURE;
   STDMETHOD(OpenLinkSource) (THIS_ DWORD dwLink) PURE;
   STDMETHOD(UpdateLink) (THIS_
         DWORD dwLink,
         BOOL fErrorMessage,
         BOOL fErrorAction) PURE;
   STDMETHOD(CancelLink) (THIS_ DWORD dwLink) PURE;
};
#define LPOLEUILTSLINKCONTAINER     IOleUILtsLinkContainer FAR*
#undef  INTERFACE
#define INTERFACE   IOleUILtsLinkContainer
DECLARE_INTERFACE_(IOleUILtsLinkContainer, IUnknown)
{
   STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
   STDMETHOD_(ULONG,AddRef) (THIS) PURE;
   STDMETHOD_(ULONG,Release) (THIS) PURE;
   STDMETHOD (GetLinkSourceEx)        ( THIS_
                                         DWORD       dwLink,
                                         LPASWOLESTR FAR * lplpszLinkName,
                                         LPASWOLESTR FAR * lplpszSourceName,
                                         ULONG FAR * lplenFileName,
                                         LPASWOLESTR FAR * lplpszFullLinkType,
                                         LPASWOLESTR FAR * lplpszShortLinkType,
                                         BOOL FAR *  lpbSourceAvailable,
                                         BOOL FAR *  lpbIsSelected,
                                         BOOL FAR *  lpbIsBasket,
                                         DWORD FAR * lpdwSupportedMask) PURE;
   STDMETHOD  (GetBasketInfo)         ( THIS_
                                         DWORD       dwLink,
                                         LPASWOLESTR FAR * lplpszBasketText,
                                         BOOL FAR *  lpbUpdateAsGroup) PURE;
   STDMETHOD  (SetCurrentBasket)      ( THIS_
                                         DWORD        dwBasket) PURE;
   STDMETHOD  (GetCurrentBasket)      ( THIS_
                                         DWORD FAR *  lpdwBasket) PURE;
};
typedef struct tagOLEUILTSMANAGELINKS
{
   DWORD          cbStruct;      
   DWORD          dwFlags;       
   HWND           hWndOwner;     
   LPASWCOLESTR   lpszCaption;   
   LPFNOLEUIHOOK  lpfnHook;      
   LPARAM         lCustData;     
   HINSTANCE      hInstance;     
   LPASWCOLESTR   lpszTemplate;  
   HRSRC          hResource;     
   LPOLEUILINKCONTAINER lpOleUILinkContainer;   
   LPOLEUILTSLINKCONTAINER lpOleUILtsLinkContainer;
   int            nDialogID;     
   BOOL           fIsAuto;       
   DWORD          dwCurrentBasket;
} OLEUILTSMANAGELINKS, *POLEUILTSMANAGELINKS, FAR *LPOLEUILTSMANAGELINKS;
typedef OLEUILTSMANAGELINKS   OLEUIEDITLINKS;
typedef POLEUILTSMANAGELINKS  POLEUIEDITLINKS;
typedef LPOLEUILTSMANAGELINKS LPOLEUIEDITLINKS;
STDAPI_(STDEXPORT UINT) OleUIEditLinks(LPOLEUIEDITLINKS);
STDAPI_(STDEXPORT UINT) OleUILtsManageLinks(LPOLEUILTSMANAGELINKS);
#define MLF_SHOWHELP                0x00000001L
#define MLF_DISABLEUPDATENOW        0x00000002L
#define MLF_DISABLEOPENSOURCE       0x00000004L
#define MLF_DISABLECHANGESOURCE     0x00000008L
#define MLF_DISABLECANCELLINK       0x00000010L
#define MLF_CONFIRMBREAKLINK        0x00000020L 
#define ELF_SHOWHELP                MLF_SHOWHELP           
#define ELF_DISABLEUPDATENOW        MLF_DISABLEUPDATENOW   
#define ELF_DISABLEOPENSOURCE       MLF_DISABLEOPENSOURCE  
#define ELF_DISABLECHANGESOURCE     MLF_DISABLECHANGESOURCE
#define ELF_DISABLECANCELLINK       MLF_DISABLECANCELLINK  
#define MLF_SUPPORTSUPDATENOW       0x00000001L
#define MLF_SUPPORTSOPENSOURCE      0x00000002L
#define MLF_SUPPORTSCHANGESOURCE    0x00000004L
#define MLF_SUPPORTSCANCELLINK      0x00000008L
#define MLF_SUPPORTSUPDATESTATUS    0x00000010L
#define OLEUI_MLERR_LPOLEUILINKCONTAINERNULL       (OLEUI_ERR_STANDARDMAX+0)
#define OLEUI_MLERR_LPOLEUILINKCONTAINERINVALID    (OLEUI_ERR_STANDARDMAX+1)
#define OLEUI_MLERR_LPOLEUILTSLINKCONTAINERINVALID (OLEUI_ERR_STANDARDMAX+2)
#define OLEUI_MLERR_LPOLEUILTSLINKCONTAINERNULL    (OLEUI_ERR_STANDARDMAX+3)
#define OLEUI_MLERR_FAILEDGETTINGCURRENTBASKET     (OLEUI_ERR_STANDARDMAX+4)
#define OLEUI_ELERR_LPOLEUILINKCONTAINERNULL       OLEUI_MLERR_LPOLEUILINKCONTAINERNULL       
#define OLEUI_ELERR_LPOLEUILINKCONTAINERINVALID    OLEUI_MLERR_LPOLEUILINKCONTAINERINVALID    
#define OLEUI_ELERR_LPOLEUILTSLINKCONTAINERINVALID OLEUI_MLERR_LPOLEUILTSLINKCONTAINERINVALID 
#define OLEUI_ELERR_LPOLEUILTSLINKCONTAINERNULL    OLEUI_MLERR_LPOLEUILTSLINKCONTAINERNULL    
#define ID_EL_CHANGESOURCE             201
#define ID_EL_AUTOMATIC                202
#define ID_EL_CLOSE                    208
#define ID_EL_CANCELLINK               209
#define ID_EL_UPDATENOW                210
#define ID_EL_OPENSOURCE               211
#define ID_EL_MANUAL                   212
#define ID_EL_LINKSOURCE               216
#define ID_EL_LINKTYPE                 217
#define ID_EL_UPDATE                   218
#define ID_EL_NULL                     -1
#define ID_EL_LINKSLISTBOX             206
#define ID_EL_COL1                     220
#define ID_EL_COL2                     221
#define ID_EL_COL3                     222
#define ID_ML_COL4                     223 
typedef struct tagOLEUICHANGESOURCE
{
   DWORD          cbStruct;         
   DWORD          dwFlags;          
   HWND           hWndOwner;        
   LPASWCOLESTR   lpszCaption;      
   LPFNOLEUIHOOK  lpfnHook;         
   LPARAM         lCustData;        
   HINSTANCE      hInstance;        
   LPASWCOLESTR   lpszTemplate;     
   HRSRC          hResource;        
   LPOPENFILENAME lpOfn;          
   LPOLEUILINKCONTAINER           
                  lpOleUILinkContainer;  
   LPOLEUILTSLINKCONTAINER        
                  lpOleUILtsLinkContainer;  
   DWORD          dwLink;         
   LPASWOLESTR    lpszDisplayName;
   ULONG          lenFileName;    
   BOOL           fValidLink;     
   LPASWOLESTR    lpszFrom;       
   LPASWOLESTR    lpszTo;         
   UINT           uDialogReturn;  
} OLEUICHANGESOURCE, *POLEUICHANGESOURCE,  FAR *LPOLEUICHANGESOURCE;
STDAPI_(STDEXPORT UINT) OleUIChangeSource(LPOLEUICHANGESOURCE);
#define CSF_SHOWHELP                0x00000001L
#define OLEUI_CSERR_LPOFNNOTNULL                   (OLEUI_ERR_STANDARDMAX+1)
#define OLEUI_CSERR_LPOLEUILINKCONTAINERINVALID    (OLEUI_ERR_STANDARDMAX+2)
#define OLEUI_CSERR_LPOLEUILINKCONTAINERNULL       (OLEUI_ERR_STANDARDMAX+3)
#define OLEUI_CSERR_LPOLEUILTSLINKCONTAINERINVALID (OLEUI_ERR_STANDARDMAX+4)
#define OLEUI_CSERR_LPOLEUILTSLINKCONTAINERNULL    (OLEUI_ERR_STANDARDMAX+5)
#define OLEUI_CSERR_LPSZDISPLAYNAMEINVALID         (OLEUI_ERR_STANDARDMAX+6)
#define OLEUI_CSERR_FVALIDLINKNOTFALSE             (OLEUI_ERR_STANDARDMAX+7)
#define OLEUI_CSERR_LPSZFROMNOTNULL                (OLEUI_ERR_STANDARDMAX+8)
#define OLEUI_CSERR_LPSZTONOTNULL                  (OLEUI_ERR_STANDARDMAX+9)
#define OLEUI_CSERR_GETLINKSOURCEEXFAILED          (OLEUI_ERR_STANDARDMAX+10)
#define OLEUI_CSERR_COMMDLGLOADLIBRARYFAILURE      (OLEUI_ERR_STANDARDMAX+11)
#define IDS_CSOK                    32420
typedef struct tagOLEUICHANGEICON
   {
   DWORD           cbStruct;       
   DWORD           dwFlags;        
   HWND            hWndOwner;      
   LPASWCOLESTR    lpszCaption;    
   LPFNOLEUIHOOK   lpfnHook;       
   LPARAM          lCustData;      
   HINSTANCE       hInstance;      
   LPASWCOLESTR    lpszTemplate;   
   HRSRC           hResource;      
   HGLOBAL         hMetaPict;      
   CLSID           clsid;          
   ASWOLECHAR      szIconExe[OLEUI_CCHPATHMAX];
   int             cchIconExe;
   } OLEUICHANGEICON, *POLEUICHANGEICON, FAR *LPOLEUICHANGEICON;
STDAPI_(STDEXPORT UINT) OleUIChangeIcon(LPOLEUICHANGEICON);
#define CIF_SHOWHELP                0x00000001L
#define CIF_SELECTCURRENT           0x00000002L
#define CIF_SELECTDEFAULT           0x00000004L
#define CIF_SELECTFROMFILE          0x00000008L
#define CIF_USEICONEXE              0x0000000aL
#define OLEUI_CIERR_MUSTHAVECLSID           (OLEUI_ERR_STANDARDMAX+0)
#define OLEUI_CIERR_MUSTHAVECURRENTMETAFILE (OLEUI_ERR_STANDARDMAX+1)
#define OLEUI_CIERR_SZICONEXEINVALID        (OLEUI_ERR_STANDARDMAX+2)
#define ID_GROUP                    120
#define ID_CURRENT                  121
#define ID_CURRENTICON              122
#define ID_DEFAULT                  123
#define ID_DEFAULTICON              124
#define ID_FROMFILE                 125
#define ID_FROMFILEEDIT             126
#define ID_ICONLIST                 127
#define ID_LABEL                    128
#define ID_LABELEDIT                129
#define ID_BROWSE                   130
#define ID_RESULTICON               132
#define ID_RESULTLABEL              133
#define IDS_CINOICONSINFILE         32430
#define IDS_CIINVALIDFILE           32431
#define IDS_CIFILEACCESS            32432
#define IDS_CIFILESHARE             32433
#define IDS_CIFILEOPENFAIL          32434
typedef struct tagOLEUICONVERT
   {
   DWORD           cbStruct;         
   DWORD           dwFlags;          
   HWND            hWndOwner;        
   LPASWCOLESTR    lpszCaption;      
   LPFNOLEUIHOOK   lpfnHook;         
   LPARAM          lCustData;        
   HINSTANCE       hInstance;        
   LPASWCOLESTR    lpszTemplate;     
   HRSRC           hResource;        
   CLSID           clsid;            
   CLSID           clsidConvertDefault;  
   CLSID           clsidActivateDefault;  
   CLSID           clsidNew;         
   DWORD           dvAspect;         
   WORD            wFormat;          
   BOOL            fIsLinkedObject;  
   HGLOBAL         hMetaPict;        
   LPASWOLESTR     lpszUserType;     
   BOOL            fObjectsIconChanged;  
   LPASWOLESTR     lpszDefLabel;     
   UINT            cClsidExclude;    
   LPCLSID         lpClsidExclude;   
   } OLEUICONVERT, *POLEUICONVERT, FAR *LPOLEUICONVERT;
STDAPI_(STDEXPORT UINT) OleUIConvert(LPOLEUICONVERT);
STDAPI_(STDEXPORT BOOL) OleUICanConvertOrActivateAs(
      REFCLSID    rClsid,
      BOOL        fIsLinkedObject,
      WORD        wFormat
);
#define CF_SHOWHELPBUTTON          0x00000001L
#define CF_SETCONVERTDEFAULT       0x00000002L
#define CF_SETACTIVATEDEFAULT       0x00000004L
#define CF_SELECTCONVERTTO         0x00000008L
#define CF_SELECTACTIVATEAS        0x00000010L
#define CF_DISABLEDISPLAYASICON    0x00000020L
#define CF_DISABLEACTIVATEAS       0x00000040L
#define OLEUI_CTERR_CLASSIDINVALID      (OLEUI_ERR_STANDARDMAX+1)
#define OLEUI_CTERR_DVASPECTINVALID     (OLEUI_ERR_STANDARDMAX+2)
#define OLEUI_CTERR_CBFORMATINVALID     (OLEUI_ERR_STANDARDMAX+3)
#define OLEUI_CTERR_HMETAPICTINVALID    (OLEUI_ERR_STANDARDMAX+4)
#define OLEUI_CTERR_STRINGINVALID       (OLEUI_ERR_STANDARDMAX+5)
#define IDCV_OBJECTTYPE             150
#define IDCV_DISPLAYASICON          152
#define IDCV_CHANGEICON             153
#define IDCV_ACTIVATELIST           154
#define IDCV_CONVERTTO              155
#define IDCV_ACTIVATEAS             156
#define IDCV_RESULTTEXT             157
#define IDCV_CONVERTLIST            158
#define IDCV_ICON                   159
#define IDCV_ICONLABEL1             160
#define IDCV_ICONLABEL2             161
#define IDCV_STXCURTYPE             162
#define IDCV_GRPRESULT              163
#define IDCV_STXCONVERTTO           164
#define IDS_CVRESULTCONVERTLINK     32440
#define IDS_CVRESULTCONVERTTO       32441
#define IDS_CVRESULTNOCHANGE        32442
#define IDS_CVRESULTDISPLAYASICON   32443
#define IDS_CVRESULTACTIVATEAS      32444
#define IDS_CVRESULTACTIVATEDIFF    32445
typedef struct tagOLEUIBUSY
   {
   DWORD           cbStruct;         
   DWORD           dwFlags;          
   HWND            hWndOwner;        
   LPASWCOLESTR    lpszCaption;      
   LPFNOLEUIHOOK   lpfnHook;         
   LPARAM          lCustData;        
   HINSTANCE       hInstance;        
   LPASWCOLESTR    lpszTemplate;     
   HRSRC           hResource;        
   HTASK           hTask;            
   HWND FAR *      lphWndDialog;     
   } OLEUIBUSY, *POLEUIBUSY, FAR *LPOLEUIBUSY;
STDAPI_(STDEXPORT UINT) OleUIBusy(LPOLEUIBUSY);
#define BZ_DISABLECANCELBUTTON          0x00000001L
#define BZ_DISABLESWITCHTOBUTTON        0x00000002L
#define BZ_DISABLERETRYBUTTON           0x00000004L
#define BZ_NOTRESPONDINGDIALOG          0x00000008L
#define OLEUI_BZERR_HTASKINVALID    (OLEUI_ERR_STANDARDMAX+0)
#define OLEUI_BZ_SWITCHTOSELECTED   (OLEUI_ERR_STANDARDMAX+1)
#define OLEUI_BZ_RETRYSELECTED      (OLEUI_ERR_STANDARDMAX+2)
#define OLEUI_BZ_CALLUNBLOCKED      (OLEUI_ERR_STANDARDMAX+3)
#define OLEUI_BZERR_NOTIMPLIN32BIT  (OLEUI_ERR_STANDARDMAX+4)
#define IDBZ_RETRY                      600
#define IDBZ_ICON                       601
#define IDBZ_MESSAGE1                   602
#define IDBZ_SWITCHTO                   604
#define IDS_BZRESULTTEXTBUSY            32450
#define IDS_BZRESULTTEXTNOTRESPONDING   32451
#define IDS_LINK_AUTO           32460
#define IDS_LINK_MANUAL         32461
#define IDS_LINK_UNKNOWN        32462
#define IDS_LINKS               32463
#define IDS_FAILED              32464
#define IDS_CHANGESOURCE        32465
#define IDS_INVALIDSOURCE       32466
#define IDS_ERR_GETLINKSOURCE   32467
#define IDS_ERR_GETLINKUPDATEOPTIONS    32468
#define IDS_ERR_ADDSTRING       32469
#define IDS_ERR_GETBASKETINFO   32470  
#define IDS_CHANGEADDITIONALLINKS  32471
#define IDS_CLOSE               32472
#define IDS_BREAKLINK           32473
#define IDS_UPDATENOW           32474
#define ID_PU_LINKS             900
#define ID_PU_TEXT              901
#define ID_PU_CONVERT           902
#define ID_PU_BROWSE            904
#define ID_PU_METER             905
#define ID_PU_PERCENT           906
#define ID_PU_STOP              907
#define ID_DUMMY    999
#ifdef __cplusplus
extern "C"
#endif
int FAR CDECL OleUIPromptUser(WORD nTemplate, HWND hwndParent, ...);
#define UPDATELINKS_STARTDELAY  2000    
STDAPI_(STDEXPORT BOOL) OleUIUpdateLinks(
      LPOLEUILINKCONTAINER lpOleUILinkCntr,
      HWND hwndParent,
      LPASWOLESTR lpszTitle,
      int cLinks);
#define OLEUI_HANDLES_USEINVERSE    0x00000001L
#define OLEUI_HANDLES_NOBORDER      0x00000002L
#define OLEUI_HANDLES_INSIDE        0x00000004L
#define OLEUI_HANDLES_OUTSIDE       0x00000008L
#define OLEUI_SHADE_FULLRECT        1
#define OLEUI_SHADE_BORDERIN        2
#define OLEUI_SHADE_BORDEROUT       3
STDAPI_(STDEXPORT void) OleUIDrawHandles(LPRECT lpRect, HDC hdc, DWORD dwFlags, UINT cSize, BOOL fDraw);
STDAPI_(STDEXPORT void) OleUIDrawShading(LPRECT lpRect, HDC hdc, DWORD dwFlags, UINT cWidth);
STDAPI_(STDEXPORT void) OleUIShowObject(LPCRECT lprc, HDC hdc, BOOL fIsLink);
#define DEFAULT_HATCHBORDER_WIDTH   4
STDAPI_(STDEXPORT BOOL) RegisterHatchWindowClass(HINSTANCE hInst);
STDAPI_(STDEXPORT HWND) CreateHatchWindow(HWND hWndParent, HINSTANCE hInst);
STDAPI_(STDEXPORT UINT) GetHatchWidth(HWND hWndHatch);
STDAPI_(STDEXPORT void) GetHatchRect(HWND hWndHatch, LPRECT lpHatchRect);
STDAPI_(STDEXPORT void) SetHatchRect(HWND hWndHatch, LPRECT lprcHatchRect);
STDAPI_(STDEXPORT void) SetHatchWindowSize(
      HWND        hWndHatch,
      LPRECT      lprcIPObjRect,
      LPRECT      lprcClipRect,
      LPPOINT     lpptOffset
);
typedef void (*PFNRECTCALLOUT)(HWND hwndHatch, DWORD dwCookie, LPRECT prc);
STDAPI_(STDEXPORT void) SetHatchClipRect(HWND hWndHatch, LPRECT lprcClipRect);
STDAPI_(STDEXPORT void) SetHatchAdjustRectCallout(HWND hWndHatch, PFNRECTCALLOUT pfn, DWORD dwCookie);
STDAPI_(STDEXPORT void) SetOnHatchRectChange(HWND hWndHatch, PFNRECTCALLOUT pfn, DWORD dwCookie);
STDAPI_(STDEXPORT void) EnableHatchHandles(HWND hWndHatch, BOOL fEnable);
#define OLEUI_VERSION_MAGIC 0x4D42
STDAPI_(STDEXPORT int) OleUILtsLoadString (UINT uStringID, LPSTR lpszString, 
                                 int iStringSize);
#include <aspop.h>
#include <asmsgftr.h>
#ifdef __cplusplus
}
#endif
#if ( _MSC_VER >= 800 )
#pragma warning(default:4001)
#endif
#endif  
