/* NOSHIP */
#ifndef _IGBMHELP_
#define _IGBMHELP_
/*******************************************************************************
* FILE NAME: igbmhelp.h                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the class(es):                                              *
*     IGBMHELP.H  Internal helpers for GBM file I/O stuff                      *
*                                                                              *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>

extern IBase::Boolean gbm_same(char *s1, char *s2, int n);
extern char *gbm_find_word(char *str, char *substr);
extern char *gbm_find_word_prefix(char *str, char *substr);

#define AHEAD_BUF 0x4000

typedef struct
        {
        byte buf[AHEAD_BUF];
        int inx, cnt;
        int fd;
        } AHEAD;

extern AHEAD *gbm_create_ahead(int fd);
extern void gbm_destroy_ahead(AHEAD *ahead);
extern int gbm_read_ahead(AHEAD *ahead);

#endif // _IGBMHELP_
