/* NOSHIP */
#ifndef _IPROFPRV_
  #define _IPROFPRV_
/*******************************************************************************
* FILE NAME: iprofprv.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IProfileData                                                             *
*     IProfileCursorData                                                       *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>

#pragma pack(4)

class IProfileData : public IBase
{
public:
  IProfileData( );
 ~IProfileData( );

#ifdef IC_WIN
Boolean
  isSystemProfile;
const IString
  defaultString;
HKEY
  hKey;
#endif //IC_WIN

/*----------------------- Private -----------------------------------*/
private:
  IProfileData ( const IProfileData& aProfile );
IProfileData
 &operator=    ( const IProfileData& aProfile );
}; // IProfileData

class IProfileCursorData : public IBase
{
public:
  IProfileCursorData( );
 ~IProfileCursorData( );

#ifdef IC_WIN
IString
  profileName;
Boolean
  isSystemProfile;
const IString
  defaultString;
#endif

/*----------------------- Private -----------------------------------*/
private:
  IProfileCursorData ( const IProfileCursorData& aCursor );
IProfileCursorData
 &operator=          ( const IProfileCursorData& aCursor );
}; // IProfileCursorData

#pragma pack()

#endif // _IPROFPRV_
