/* NOSHIP */
#ifndef _ISTATHDR_
  #define _ISTATHDR_
/*******************************************************************************
* FILE NAME: istathdr.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IStaticTextHandler                                                       *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
#include <ipainhdr.hpp>

#pragma pack(4)

class IStaticText;

class IStaticTextHandler : public IPaintHandler {
typedef IPaintHandler
  Inherited;
public:
/*------------------------------- Constructor ----------------------------------
| The only way to construct instances of this class is to use the default      |
| constructor, which does not take any arguments.                              |
------------------------------------------------------------------------------*/
  IStaticTextHandler ( );

virtual
 ~IStaticTextHandler ( );

protected:
/*---------------------------- Event Dispatching -------------------------------
| In Windows we override dispatchHandlerEvent to process WM_WINDOWPOSCHANGED   |
| messages.  We could use a resize handler to do the same thing but            |
| it is done this way to stay to one default handler.                          |
------------------------------------------------------------------------------*/
#ifdef IC_WIN
virtual Boolean
  dispatchHandlerEvent ( IEvent& event );
#endif

/*-------------------------------- Overrides -----------------------------------
| This inherited function is overridden:                                       |
|   paintWindow - Process the paint events for a static text control window.   |
------------------------------------------------------------------------------*/
virtual Boolean
  paintWindow          ( IPaintEvent& evt );
}; // class IStaticTextHandler

#pragma pack()

#endif // _ISTATHDR_
