/*******************************************************************************
* FILE NAME: icctlsta.cpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the implementation of classes/functions declared        *
*   in icctlsta.hpp.                                                           *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1996       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*   US Government Users Restricted Rights - Use, duplication, or disclosure    *
*   restricted by GSA ADP Schedule Contract with IBM Corp.                     *
*                                                                              *
*******************************************************************************/
// Note we depend on ireslib.cpp being first
#pragma priority( -2147482102 )
extern "C"
  {
  #include <iwindefs.h>
  #ifdef IC_WIN
    #include <iclccl.h>
    #include <iclcnrw.h>
    #include <iclnbw.h>
    #include <iclsldw.h>
    #include <iclspbw.h>
  #endif
  }

#include <icctlsta.hpp>
#include <ireslib.hpp>
#include <itrace.hpp>

#ifdef IC_WIN
// only need this code in Windows


// Segment definitions
#ifdef IC_PAGETUNE
  #define _ICCTLSTA_CPP_
  #include <ipagetun.h>
#endif


IDynamicLinkLibrary* IControlStatics::controlDynLinkLib = 0;

IS32to16SendMessage IControlStatics::lpfn32to16SendMessage = 0;
IS32to16PostMessage IControlStatics::lpfn32to16PostMessage = 0;
IS16to32Message     IControlStatics::lpfn16to32Message = 0;

/*------------------------------------------------------------------------------
| IControlStatics::loadControlDLL                                              |
------------------------------------------------------------------------------*/
IDynamicLinkLibrary& IControlStatics :: loadControlDLL ( )
  {
     if (!controlDynLinkLib)
        {
        controlDynLinkLib = new IDynamicLinkLibrary(ICL_CONTAINER_DLL);
        // The Notebook, Slider, and spinbutton are assumed to be
        // in the same DLL.
        lpfn32to16SendMessage = (IS32to16SendMessage)
                    controlDynLinkLib->procAddress("DllS32to16SendMessage");
        lpfn32to16PostMessage = (IS32to16PostMessage)
                    controlDynLinkLib->procAddress("DllS32to16PostMessage");
        lpfn16to32Message = (IS16to32Message)
                    controlDynLinkLib->procAddress("DllS16to32Message");
        }

     return *controlDynLinkLib;
  }

#endif  // IC_WIN
